/* ***********************************************************
 * This file was automatically generated on 2020-01-23.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

/**
 * Measures reflectivity of a surface
 */
public class BrickletLine extends Device {
	public final static int DEVICE_IDENTIFIER = 241;
	public final static String DEVICE_DISPLAY_NAME = "Line Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletline", DEVICE_IDENTIFIER, BrickletLine.class, BrickletLineActions.class, "2.0.1");

	public final static byte FUNCTION_GET_REFLECTIVITY = (byte)1;
	public final static byte FUNCTION_SET_REFLECTIVITY_CALLBACK_PERIOD = (byte)2;
	public final static byte FUNCTION_GET_REFLECTIVITY_CALLBACK_PERIOD = (byte)3;
	public final static byte FUNCTION_SET_REFLECTIVITY_CALLBACK_THRESHOLD = (byte)4;
	public final static byte FUNCTION_GET_REFLECTIVITY_CALLBACK_THRESHOLD = (byte)5;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)6;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)7;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_REFLECTIVITY = 8;
	private final static int CALLBACK_REFLECTIVITY_REACHED = 9;

	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';

	private List<ReflectivityListener> listenerReflectivity = new CopyOnWriteArrayList<ReflectivityListener>();
	private List<ReflectivityReachedListener> listenerReflectivityReached = new CopyOnWriteArrayList<ReflectivityReachedListener>();

	public class ReflectivityCallbackThreshold {
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletLine#setReflectivityCallbackPeriod(long)}. The parameter is the
	 * reflectivity of the sensor.
	 * 
	 * The {@link BrickletLine.ReflectivityListener} listener is only triggered if the reflectivity has
	 * changed since the last triggering.
	 */
	public interface ReflectivityListener extends DeviceListener {
		public void reflectivity(int reflectivity);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link BrickletLine#setReflectivityCallbackThreshold(char, int, int)} is reached.
	 * The parameter is the reflectivity of the sensor.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link BrickletLine#setDebouncePeriod(long)}.
	 */
	public interface ReflectivityReachedListener extends DeviceListener {
		public void reflectivityReached(int reflectivity);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletLine(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_REFLECTIVITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_REFLECTIVITY_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_REFLECTIVITY_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_REFLECTIVITY_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_REFLECTIVITY_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_REFLECTIVITY] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int reflectivity = IPConnection.unsignedShort(bb.getShort());

				for (ReflectivityListener listener: listenerReflectivity) {
					listener.reflectivity(reflectivity);
				}
			}
		};

		callbacks[CALLBACK_REFLECTIVITY_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int reflectivity = IPConnection.unsignedShort(bb.getShort());

				for (ReflectivityReachedListener listener: listenerReflectivityReached) {
					listener.reflectivityReached(reflectivity);
				}
			}
		};
	}

	/**
	 * Returns the currently measured reflectivity. The reflectivity is
	 * a value between 0 (not reflective) and 4095 (very reflective).
	 * 
	 * Usually black has a low reflectivity while white has a high
	 * reflectivity.
	 * 
	 * If you want to get the reflectivity periodically, it is recommended
	 * to use the {@link BrickletLine.ReflectivityListener} listener and set the period with
	 * {@link BrickletLine#setReflectivityCallbackPeriod(long)}.
	 */
	public int getReflectivity() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_REFLECTIVITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int reflectivity = IPConnection.unsignedShort(bb.getShort());

		return reflectivity;
	}

	/**
	 * Sets the period with which the {@link BrickletLine.ReflectivityListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletLine.ReflectivityListener} listener is only triggered if the reflectivity has
	 * changed since the last triggering.
	 */
	public void setReflectivityCallbackPeriod(long period) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_REFLECTIVITY_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletLine#setReflectivityCallbackPeriod(long)}.
	 */
	public long getReflectivityCallbackPeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_REFLECTIVITY_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the thresholds for the {@link BrickletLine.ReflectivityReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the reflectivity is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the reflectivity is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the reflectivity is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the reflectivity is greater than the min value (max is ignored)"
	 * \endverbatim
	 */
	public void setReflectivityCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_REFLECTIVITY_CALLBACK_THRESHOLD, this);

		bb.put((byte)option);
		bb.putShort((short)min);
		bb.putShort((short)max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link BrickletLine#setReflectivityCallbackThreshold(char, int, int)}.
	 */
	public ReflectivityCallbackThreshold getReflectivityCallbackThreshold() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_REFLECTIVITY_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ReflectivityCallbackThreshold obj = new ReflectivityCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = IPConnection.unsignedShort(bb.getShort());
		obj.max = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Sets the period with which the threshold listener
	 * 
	 * * {@link BrickletLine.ReflectivityReachedListener}
	 * 
	 * is triggered, if the threshold
	 * 
	 * * {@link BrickletLine#setReflectivityCallbackThreshold(char, int, int)}
	 * 
	 * keeps being reached.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the debounce period as set by {@link BrickletLine#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnection.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Reflectivity listener.
	 */
	public void addReflectivityListener(ReflectivityListener listener) {
		listenerReflectivity.add(listener);
	}

	/**
	 * Removes a Reflectivity listener.
	 */
	public void removeReflectivityListener(ReflectivityListener listener) {
		listenerReflectivity.remove(listener);
	}

	/**
	 * Adds a ReflectivityReached listener.
	 */
	public void addReflectivityReachedListener(ReflectivityReachedListener listener) {
		listenerReflectivityReached.add(listener);
	}

	/**
	 * Removes a ReflectivityReached listener.
	 */
	public void removeReflectivityReachedListener(ReflectivityReachedListener listener) {
		listenerReflectivityReached.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletLine.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletLine.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLineConfig cfg = (BrickletLineConfig) config.as(BrickletLineConfig.class);
        this.addReflectivityListener((reflectivity) -> {if(true) {updateStateFn.accept("BrickletLineReflectivity", transformBrickletLineReflectivityCallback0(reflectivity, cfg));}});
        
		{
		BrickletLineReflectivityConfig channelCfg = getChannelConfigFn.apply("BrickletLineReflectivity").as(BrickletLineReflectivityConfig.class);
		this.setReflectivityCallbackPeriod(channelCfg.updateInterval);
		this.setReflectivityCallbackThreshold('x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletLineConfig cfg = (BrickletLineConfig) config.as(BrickletLineConfig.class);
        this.listenerReflectivity.clear();
        this.setReflectivityCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletLineConfig cfg = (BrickletLineConfig) config.as(BrickletLineConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletLineReflectivity");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletLineReflectivity":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLineReflectivity"), "Reflectivity", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLineReflectivity")).withDescription("The currently measured reflectivity. The reflectivity is a value between 0 (not reflective) and 4095 (very reflective).<br/><br/>Usually black has a low reflectivity while white has a high reflectivity.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4095)).withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Line Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures reflectivity of a surface").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletLineReflectivity", new ChannelTypeUID("tinkerforge", "BrickletLineReflectivity")).withLabel("Reflectivity").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletline":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletLineReflectivity":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLineConfig cfg = (BrickletLineConfig) config.as(BrickletLineConfig.class);
        switch(channel) {
            case "BrickletLineReflectivity": {
                   BrickletLineReflectivityConfig channelCfg = channelConfig.as(BrickletLineReflectivityConfig.class);
                   {
            int value = this.getReflectivity();
            if(true)
                updateStateFn.accept(channel, transformBrickletLineReflectivityGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletLineConfig cfg = (BrickletLineConfig) config.as(BrickletLineConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletLineReflectivityCallback0(int reflectivity, BrickletLineConfig cfg) {
        return new QuantityType<>(reflectivity, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLineReflectivityGetter0(int value, BrickletLineConfig cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
}
