/* ***********************************************************
 * This file was automatically generated on 2020-01-23.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * Capacitive touch sensor for 12 electrodes
 */
public class BrickletMultiTouchV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2129;
	public final static String DEVICE_DISPLAY_NAME = "Multi Touch Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletmultitouchv2", DEVICE_IDENTIFIER, BrickletMultiTouchV2.class, BrickletMultiTouchV2Actions.class, "2.0.0");

	public final static byte FUNCTION_GET_TOUCH_STATE = (byte)1;
	public final static byte FUNCTION_SET_TOUCH_STATE_CALLBACK_CONFIGURATION = (byte)2;
	public final static byte FUNCTION_GET_TOUCH_STATE_CALLBACK_CONFIGURATION = (byte)3;
	public final static byte FUNCTION_RECALIBRATE = (byte)5;
	public final static byte FUNCTION_SET_ELECTRODE_CONFIG = (byte)6;
	public final static byte FUNCTION_GET_ELECTRODE_CONFIG = (byte)7;
	public final static byte FUNCTION_SET_ELECTRODE_SENSITIVITY = (byte)8;
	public final static byte FUNCTION_GET_ELECTRODE_SENSITIVITY = (byte)9;
	public final static byte FUNCTION_SET_TOUCH_LED_CONFIG = (byte)10;
	public final static byte FUNCTION_GET_TOUCH_LED_CONFIG = (byte)11;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_TOUCH_STATE = 4;

	public final static int TOUCH_LED_CONFIG_OFF = 0;
	public final static int TOUCH_LED_CONFIG_ON = 1;
	public final static int TOUCH_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int TOUCH_LED_CONFIG_SHOW_TOUCH = 3;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<TouchStateListener> listenerTouchState = new CopyOnWriteArrayList<TouchStateListener>();

	public class TouchStateCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * Returns the current touch state, see {@link BrickletMultiTouchV2#getTouchState()} for
	 * information about the state.
	 * 
	 * This listener is triggered every time the touch state changes with
	 * a given period (see {@link BrickletMultiTouchV2#setTouchStateCallbackConfiguration(long, boolean)})
	 */
	public interface TouchStateListener extends DeviceListener {
		public void touchState(boolean[] state);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletMultiTouchV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_TOUCH_STATE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_TOUCH_STATE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_TOUCH_STATE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RECALIBRATE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_ELECTRODE_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ELECTRODE_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_ELECTRODE_SENSITIVITY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ELECTRODE_SENSITIVITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_TOUCH_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_TOUCH_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_TOUCH_STATE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				byte[] stateBits = new byte[2];
				bb.get(stateBits);
				boolean[] state = new boolean[13];
				for (int i = 0; i < 13; i++) {
					state[i] = (stateBits[i / 8] & (1 << (i % 8))) != 0;
				}


				for (TouchStateListener listener: listenerTouchState) {
					listener.touchState(state);
				}
			}
		};
	}

	/**
	 * Returns the current touch state. The state is given as a array of
	 * bools.
	 * 
	 * Element 0 to 11 represent the 12 electrodes and element 12 represents
	 * the proximity.
	 * 
	 * If an electrode is touched, the corresponding element is *true*. If
	 * a hand or similar is in proximity to the electrodes, element 12 is
	 * *true*.
	 * 
	 * The proximity is activated with a distance of 1-2cm. An electrode
	 * is already counted as touched if a finger is nearly touching the
	 * electrode. This means that you can put a piece of paper or foil
	 * or similar on top of a electrode to build a touch panel with
	 * a professional look.
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletMultiTouchV2.TouchStateListener} listener. You can set the listener configuration
	 * with {@link BrickletMultiTouchV2#setTouchStateCallbackConfiguration(long, boolean)}.
	 */
	public boolean[] getTouchState() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TOUCH_STATE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		byte[] stateBits = new byte[2];
		bb.get(stateBits);
		boolean[] state = new boolean[13];
		for (int i = 0; i < 13; i++) {
			state[i] = (stateBits[i / 8] & (1 << (i % 8))) != 0;
		}


		return state;
	}

	/**
	 * The period is the period with which the {@link BrickletMultiTouchV2.TouchStateListener} listener
	 * is triggered periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change within the
	 * period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 */
	public void setTouchStateCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_TOUCH_STATE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by
	 * {@link BrickletMultiTouchV2#setTouchStateCallbackConfiguration(long, boolean)}.
	 */
	public TouchStateCallbackConfiguration getTouchStateCallbackConfiguration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TOUCH_STATE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		TouchStateCallbackConfiguration obj = new TouchStateCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Recalibrates the electrodes. Call this function whenever you changed
	 * or moved you electrodes.
	 */
	public void recalibrate() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RECALIBRATE, this);


		sendRequest(bb.array());
	}

	/**
	 * Enables/disables electrodes with a bool array (see {@link BrickletMultiTouchV2#getTouchState()}).
	 * 
	 * *True* enables the electrode, *false* disables the electrode. A
	 * disabled electrode will always return *false* as its state. If you
	 * don't need all electrodes you can disable the electrodes that are
	 * not needed.
	 * 
	 * It is recommended that you disable the proximity electrode (element 12) if
	 * the proximity feature is not needed. This will reduce the amount of
	 * traffic that is produced by the {@link BrickletMultiTouchV2.TouchStateListener} listener.
	 * 
	 * Disabling electrodes will also reduce power consumption.
	 */
	public void setElectrodeConfig(boolean[] enabledElectrodes) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_ELECTRODE_CONFIG, this);


		byte[] enabledElectrodesBits = new byte[2];
		Arrays.fill(enabledElectrodesBits, (byte)0);

		for (int i = 0; i < 13; i++) {
			if (enabledElectrodes[i]) {
				enabledElectrodesBits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 2; i++) {
			bb.put(enabledElectrodesBits[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the electrode configuration, as set by {@link BrickletMultiTouchV2#setElectrodeConfig(boolean[])}.
	 */
	public boolean[] getElectrodeConfig() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ELECTRODE_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		byte[] enabledElectrodesBits = new byte[2];
		bb.get(enabledElectrodesBits);
		boolean[] enabledElectrodes = new boolean[13];
		for (int i = 0; i < 13; i++) {
			enabledElectrodes[i] = (enabledElectrodesBits[i / 8] & (1 << (i % 8))) != 0;
		}


		return enabledElectrodes;
	}

	/**
	 * Sets the sensitivity of the electrodes. An electrode with a high sensitivity
	 * will register a touch earlier then an electrode with a low sensitivity.
	 * 
	 * If you build a big electrode you might need to decrease the sensitivity, since
	 * the area that can be charged will get bigger. If you want to be able to
	 * activate an electrode from further away you need to increase the sensitivity.
	 * 
	 * After a new sensitivity is set, you likely want to call {@link BrickletMultiTouchV2#recalibrate()}
	 * to calibrate the electrodes with the newly defined sensitivity.
	 */
	public void setElectrodeSensitivity(int sensitivity) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_ELECTRODE_SENSITIVITY, this);

		bb.put((byte)sensitivity);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current sensitivity, as set by {@link BrickletMultiTouchV2#setElectrodeSensitivity(int)}.
	 */
	public int getElectrodeSensitivity() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ELECTRODE_SENSITIVITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int sensitivity = IPConnection.unsignedByte(bb.get());

		return sensitivity;
	}

	/**
	 * Configures the touch LED to be either turned off, turned on, blink in
	 * heartbeat mode or show the touch state (electrode touched = LED on).
	 */
	public void setTouchLEDConfig(int config) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_TOUCH_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the LED configuration as set by {@link BrickletMultiTouchV2#setTouchLEDConfig(int)}
	 */
	public int getTouchLEDConfig() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TOUCH_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletMultiTouchV2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletMultiTouchV2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletMultiTouchV2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletMultiTouchV2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a TouchState listener.
	 */
	public void addTouchStateListener(TouchStateListener listener) {
		listenerTouchState.add(listener);
	}

	/**
	 * Removes a TouchState listener.
	 */
	public void removeTouchStateListener(TouchStateListener listener) {
		listenerTouchState.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletMultiTouchV2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletMultiTouchV2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletMultiTouchV2Config cfg = (BrickletMultiTouchV2Config) config.as(BrickletMultiTouchV2Config.class);
        this.addTouchStateListener((state) -> {if(true) {updateStateFn.accept("BrickletMultiTouchV2Electrode0", transformBrickletMultiTouchV2Electrode0Callback0(state, cfg));}});
		this.addTouchStateListener((state) -> {if(true) {updateStateFn.accept("BrickletMultiTouchV2Electrode1", transformBrickletMultiTouchV2Electrode1Callback0(state, cfg));}});
		this.addTouchStateListener((state) -> {if(true) {updateStateFn.accept("BrickletMultiTouchV2Electrode2", transformBrickletMultiTouchV2Electrode2Callback0(state, cfg));}});
		this.addTouchStateListener((state) -> {if(true) {updateStateFn.accept("BrickletMultiTouchV2Electrode3", transformBrickletMultiTouchV2Electrode3Callback0(state, cfg));}});
		this.addTouchStateListener((state) -> {if(true) {updateStateFn.accept("BrickletMultiTouchV2Electrode4", transformBrickletMultiTouchV2Electrode4Callback0(state, cfg));}});
		this.addTouchStateListener((state) -> {if(true) {updateStateFn.accept("BrickletMultiTouchV2Electrode5", transformBrickletMultiTouchV2Electrode5Callback0(state, cfg));}});
		this.addTouchStateListener((state) -> {if(true) {updateStateFn.accept("BrickletMultiTouchV2Electrode6", transformBrickletMultiTouchV2Electrode6Callback0(state, cfg));}});
		this.addTouchStateListener((state) -> {if(true) {updateStateFn.accept("BrickletMultiTouchV2Electrode7", transformBrickletMultiTouchV2Electrode7Callback0(state, cfg));}});
		this.addTouchStateListener((state) -> {if(true) {updateStateFn.accept("BrickletMultiTouchV2Electrode8", transformBrickletMultiTouchV2Electrode8Callback0(state, cfg));}});
		this.addTouchStateListener((state) -> {if(true) {updateStateFn.accept("BrickletMultiTouchV2Electrode9", transformBrickletMultiTouchV2Electrode9Callback0(state, cfg));}});
		this.addTouchStateListener((state) -> {if(true) {updateStateFn.accept("BrickletMultiTouchV2Electrode10", transformBrickletMultiTouchV2Electrode10Callback0(state, cfg));}});
		this.addTouchStateListener((state) -> {if(true) {updateStateFn.accept("BrickletMultiTouchV2Electrode11", transformBrickletMultiTouchV2Electrode11Callback0(state, cfg));}});
		this.addTouchStateListener((state) -> {if(true) {updateStateFn.accept("BrickletMultiTouchV2Proximity", transformBrickletMultiTouchV2ProximityCallback0(state, cfg));}});
        this.setElectrodeSensitivity(cfg.sensitivity.shortValue());
		        this.recalibrate();
		        this.setElectrodeConfig(new boolean[]{cfg.electrode0Enabled, cfg.electrode1Enabled, cfg.electrode2Enabled, cfg.electrode3Enabled, cfg.electrode4Enabled, cfg.electrode5Enabled, cfg.electrode6Enabled, cfg.electrode7Enabled, cfg.electrode8Enabled, cfg.electrode9Enabled, cfg.electrode10Enabled, cfg.electrode11Enabled, cfg.proximityEnabled});
		        this.setTouchStateCallbackConfiguration(cfg.electrodeUpdateInterval, true);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		if (cfg.electrode0Enabled) {
		BrickletMultiTouchV2ElectrodeConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Electrode0").as(BrickletMultiTouchV2ElectrodeConfig.class);
		
		}
		if (cfg.electrode1Enabled) {
		BrickletMultiTouchV2ElectrodeConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Electrode1").as(BrickletMultiTouchV2ElectrodeConfig.class);
		
		}
		if (cfg.electrode2Enabled) {
		BrickletMultiTouchV2ElectrodeConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Electrode2").as(BrickletMultiTouchV2ElectrodeConfig.class);
		
		}
		if (cfg.electrode3Enabled) {
		BrickletMultiTouchV2ElectrodeConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Electrode3").as(BrickletMultiTouchV2ElectrodeConfig.class);
		
		}
		if (cfg.electrode4Enabled) {
		BrickletMultiTouchV2ElectrodeConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Electrode4").as(BrickletMultiTouchV2ElectrodeConfig.class);
		
		}
		if (cfg.electrode5Enabled) {
		BrickletMultiTouchV2ElectrodeConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Electrode5").as(BrickletMultiTouchV2ElectrodeConfig.class);
		
		}
		if (cfg.electrode6Enabled) {
		BrickletMultiTouchV2ElectrodeConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Electrode6").as(BrickletMultiTouchV2ElectrodeConfig.class);
		
		}
		if (cfg.electrode7Enabled) {
		BrickletMultiTouchV2ElectrodeConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Electrode7").as(BrickletMultiTouchV2ElectrodeConfig.class);
		
		}
		if (cfg.electrode8Enabled) {
		BrickletMultiTouchV2ElectrodeConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Electrode8").as(BrickletMultiTouchV2ElectrodeConfig.class);
		
		}
		if (cfg.electrode9Enabled) {
		BrickletMultiTouchV2ElectrodeConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Electrode9").as(BrickletMultiTouchV2ElectrodeConfig.class);
		
		}
		if (cfg.electrode10Enabled) {
		BrickletMultiTouchV2ElectrodeConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Electrode10").as(BrickletMultiTouchV2ElectrodeConfig.class);
		
		}
		if (cfg.electrode11Enabled) {
		BrickletMultiTouchV2ElectrodeConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Electrode11").as(BrickletMultiTouchV2ElectrodeConfig.class);
		
		}
		if (cfg.proximityEnabled) {
		BrickletMultiTouchV2ElectrodeConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Proximity").as(BrickletMultiTouchV2ElectrodeConfig.class);
		
		}
		{
		BrickletMultiTouchV2RecalibrateConfig channelCfg = getChannelConfigFn.apply("BrickletMultiTouchV2Recalibrate").as(BrickletMultiTouchV2RecalibrateConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletMultiTouchV2Config cfg = (BrickletMultiTouchV2Config) config.as(BrickletMultiTouchV2Config.class);
        this.listenerTouchState.clear();
		this.listenerTouchState.clear();
		this.listenerTouchState.clear();
		this.listenerTouchState.clear();
		this.listenerTouchState.clear();
		this.listenerTouchState.clear();
		this.listenerTouchState.clear();
		this.listenerTouchState.clear();
		this.listenerTouchState.clear();
		this.listenerTouchState.clear();
		this.listenerTouchState.clear();
		this.listenerTouchState.clear();
		this.listenerTouchState.clear();
        
		
		
		
		
		
		
		
		
		
		
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletMultiTouchV2Config cfg = (BrickletMultiTouchV2Config) config.as(BrickletMultiTouchV2Config.class);
        List<String> result = new ArrayList<String>();
        if (cfg.electrode0Enabled) {
                result.add("BrickletMultiTouchV2Electrode0");
            }
		if (cfg.electrode1Enabled) {
                result.add("BrickletMultiTouchV2Electrode1");
            }
		if (cfg.electrode2Enabled) {
                result.add("BrickletMultiTouchV2Electrode2");
            }
		if (cfg.electrode3Enabled) {
                result.add("BrickletMultiTouchV2Electrode3");
            }
		if (cfg.electrode4Enabled) {
                result.add("BrickletMultiTouchV2Electrode4");
            }
		if (cfg.electrode5Enabled) {
                result.add("BrickletMultiTouchV2Electrode5");
            }
		if (cfg.electrode6Enabled) {
                result.add("BrickletMultiTouchV2Electrode6");
            }
		if (cfg.electrode7Enabled) {
                result.add("BrickletMultiTouchV2Electrode7");
            }
		if (cfg.electrode8Enabled) {
                result.add("BrickletMultiTouchV2Electrode8");
            }
		if (cfg.electrode9Enabled) {
                result.add("BrickletMultiTouchV2Electrode9");
            }
		if (cfg.electrode10Enabled) {
                result.add("BrickletMultiTouchV2Electrode10");
            }
		if (cfg.electrode11Enabled) {
                result.add("BrickletMultiTouchV2Electrode11");
            }
		if (cfg.proximityEnabled) {
                result.add("BrickletMultiTouchV2Proximity");
            }
		result.add("BrickletMultiTouchV2Recalibrate");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletMultiTouchV2Electrode":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode"), "Electrode", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletMultiTouchV2Electrode")).withDescription("The current touch state. An electrode is already counted as touched if a finger is nearly touching the electrode. This means that you can put a piece of paper or foil or similar on top of a electrode to build a touch panel with a professional look.").build();
            case "BrickletMultiTouchV2Recalibrate":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Recalibrate"), "Recalibrate Electrodes", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletMultiTouchV2Recalibrate")).withDescription("Recalibrates the electrodes. Trigger this channel whenever you changed or moved you electrodes.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Multi Touch Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Capacitive touch sensor for 12 electrodes").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletMultiTouchV2Electrode0", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode")).withLabel("Electrode 0").build(), new ChannelDefinitionBuilder("BrickletMultiTouchV2Electrode1", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode")).withLabel("Electrode 1").build(), new ChannelDefinitionBuilder("BrickletMultiTouchV2Electrode2", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode")).withLabel("Electrode 2").build(), new ChannelDefinitionBuilder("BrickletMultiTouchV2Electrode3", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode")).withLabel("Electrode 3").build(), new ChannelDefinitionBuilder("BrickletMultiTouchV2Electrode4", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode")).withLabel("Electrode 4").build(), new ChannelDefinitionBuilder("BrickletMultiTouchV2Electrode5", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode")).withLabel("Electrode 5").build(), new ChannelDefinitionBuilder("BrickletMultiTouchV2Electrode6", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode")).withLabel("Electrode 6").build(), new ChannelDefinitionBuilder("BrickletMultiTouchV2Electrode7", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode")).withLabel("Electrode 7").build(), new ChannelDefinitionBuilder("BrickletMultiTouchV2Electrode8", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode")).withLabel("Electrode 8").build(), new ChannelDefinitionBuilder("BrickletMultiTouchV2Electrode9", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode")).withLabel("Electrode 9").build(), new ChannelDefinitionBuilder("BrickletMultiTouchV2Electrode10", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode")).withLabel("Electrode 10").build(), new ChannelDefinitionBuilder("BrickletMultiTouchV2Electrode11", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode")).withLabel("Electrode 11").build(), new ChannelDefinitionBuilder("BrickletMultiTouchV2Proximity", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Electrode")).withLabel("Proximity").withDescription("The current touch state. If a hand or similar is in proximity to the electrodes, this channel is toggled. The proximity is activated with a distance of 1-2cm. This means that you can put a piece of paper or foil or similar on top of a electrode to build a touch panel with a professional look.").build(), new ChannelDefinitionBuilder("BrickletMultiTouchV2Recalibrate", new ChannelTypeUID("tinkerforge", "BrickletMultiTouchV2Recalibrate")).withLabel("Recalibrate Electrodes").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletmultitouchv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("sensitivity", Type.INTEGER).withDefault("181").withDescription("The sensitivity of the electrodes. An electrode with a high sensitivity will register a touch earlier then an electrode with a low sensitivity.<br/><br/>If you build a big electrode you might need to decrease the sensitivity, since the area that can be charged will get bigger. If you want to be able to activate an electrode from further away you need to increase the sensitivity.").withLabel("Sensitivity").withMinimum(BigDecimal.valueOf(5)).withMaximum(BigDecimal.valueOf(201)).build(), ConfigDescriptionParameterBuilder.create("proximityEnabled", Type.BOOLEAN).withDefault("true").withDescription("True enables the proximity feature, false disables it. It is recommended that you disable the proximity feature if not needed. This will reduce the amount of traffic that is produced.").withLabel("Proximity Enabled").build(), ConfigDescriptionParameterBuilder.create("electrodeUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the electrode and proximity state in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Electrode Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("electrode0Enabled", Type.BOOLEAN).withDefault("true").withDescription("True enables the electrode, false disables the electrode. If you don't need all electrodes you can disable the electrodes that are not needed. Disabling electrodes will also reduce power consumption.").withLabel("Electrode 0 Enabled").build(), ConfigDescriptionParameterBuilder.create("electrode1Enabled", Type.BOOLEAN).withDefault("true").withDescription("True enables the electrode, false disables the electrode. If you don't need all electrodes you can disable the electrodes that are not needed. Disabling electrodes will also reduce power consumption.").withLabel("Electrode 1 Enabled").build(), ConfigDescriptionParameterBuilder.create("electrode2Enabled", Type.BOOLEAN).withDefault("true").withDescription("True enables the electrode, false disables the electrode. If you don't need all electrodes you can disable the electrodes that are not needed. Disabling electrodes will also reduce power consumption.").withLabel("Electrode 2 Enabled").build(), ConfigDescriptionParameterBuilder.create("electrode3Enabled", Type.BOOLEAN).withDefault("true").withDescription("True enables the electrode, false disables the electrode. If you don't need all electrodes you can disable the electrodes that are not needed. Disabling electrodes will also reduce power consumption.").withLabel("Electrode 3 Enabled").build(), ConfigDescriptionParameterBuilder.create("electrode4Enabled", Type.BOOLEAN).withDefault("true").withDescription("True enables the electrode, false disables the electrode. If you don't need all electrodes you can disable the electrodes that are not needed. Disabling electrodes will also reduce power consumption.").withLabel("Electrode 4 Enabled").build(), ConfigDescriptionParameterBuilder.create("electrode5Enabled", Type.BOOLEAN).withDefault("true").withDescription("True enables the electrode, false disables the electrode. If you don't need all electrodes you can disable the electrodes that are not needed. Disabling electrodes will also reduce power consumption.").withLabel("Electrode 5 Enabled").build(), ConfigDescriptionParameterBuilder.create("electrode6Enabled", Type.BOOLEAN).withDefault("true").withDescription("True enables the electrode, false disables the electrode. If you don't need all electrodes you can disable the electrodes that are not needed. Disabling electrodes will also reduce power consumption.").withLabel("Electrode 6 Enabled").build(), ConfigDescriptionParameterBuilder.create("electrode7Enabled", Type.BOOLEAN).withDefault("true").withDescription("True enables the electrode, false disables the electrode. If you don't need all electrodes you can disable the electrodes that are not needed. Disabling electrodes will also reduce power consumption.").withLabel("Electrode 7 Enabled").build(), ConfigDescriptionParameterBuilder.create("electrode8Enabled", Type.BOOLEAN).withDefault("true").withDescription("True enables the electrode, false disables the electrode. If you don't need all electrodes you can disable the electrodes that are not needed. Disabling electrodes will also reduce power consumption.").withLabel("Electrode 8 Enabled").build(), ConfigDescriptionParameterBuilder.create("electrode9Enabled", Type.BOOLEAN).withDefault("true").withDescription("True enables the electrode, false disables the electrode. If you don't need all electrodes you can disable the electrodes that are not needed. Disabling electrodes will also reduce power consumption.").withLabel("Electrode 9 Enabled").build(), ConfigDescriptionParameterBuilder.create("electrode10Enabled", Type.BOOLEAN).withDefault("true").withDescription("True enables the electrode, false disables the electrode. If you don't need all electrodes you can disable the electrodes that are not needed. Disabling electrodes will also reduce power consumption.").withLabel("Electrode 10 Enabled").build(), ConfigDescriptionParameterBuilder.create("electrode11Enabled", Type.BOOLEAN).withDefault("true").withDescription("True enables the electrode, false disables the electrode. If you don't need all electrodes you can disable the electrodes that are not needed. Disabling electrodes will also reduce power consumption.").withLabel("Electrode 11 Enabled").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletMultiTouchV2Electrode":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletMultiTouchV2Recalibrate":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletMultiTouchV2Config cfg = (BrickletMultiTouchV2Config) config.as(BrickletMultiTouchV2Config.class);
        switch(channel) {
            case "BrickletMultiTouchV2Electrode0": {
                   BrickletMultiTouchV2ElectrodeConfig channelCfg = channelConfig.as(BrickletMultiTouchV2ElectrodeConfig.class);
                   {
            boolean[] value = this.getTouchState();
            if(true)
                updateStateFn.accept(channel, transformBrickletMultiTouchV2Electrode0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletMultiTouchV2Electrode1": {
                   BrickletMultiTouchV2ElectrodeConfig channelCfg = channelConfig.as(BrickletMultiTouchV2ElectrodeConfig.class);
                   {
            boolean[] value = this.getTouchState();
            if(true)
                updateStateFn.accept(channel, transformBrickletMultiTouchV2Electrode1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletMultiTouchV2Electrode2": {
                   BrickletMultiTouchV2ElectrodeConfig channelCfg = channelConfig.as(BrickletMultiTouchV2ElectrodeConfig.class);
                   {
            boolean[] value = this.getTouchState();
            if(true)
                updateStateFn.accept(channel, transformBrickletMultiTouchV2Electrode2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletMultiTouchV2Electrode3": {
                   BrickletMultiTouchV2ElectrodeConfig channelCfg = channelConfig.as(BrickletMultiTouchV2ElectrodeConfig.class);
                   {
            boolean[] value = this.getTouchState();
            if(true)
                updateStateFn.accept(channel, transformBrickletMultiTouchV2Electrode3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletMultiTouchV2Electrode4": {
                   BrickletMultiTouchV2ElectrodeConfig channelCfg = channelConfig.as(BrickletMultiTouchV2ElectrodeConfig.class);
                   {
            boolean[] value = this.getTouchState();
            if(true)
                updateStateFn.accept(channel, transformBrickletMultiTouchV2Electrode4Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletMultiTouchV2Electrode5": {
                   BrickletMultiTouchV2ElectrodeConfig channelCfg = channelConfig.as(BrickletMultiTouchV2ElectrodeConfig.class);
                   {
            boolean[] value = this.getTouchState();
            if(true)
                updateStateFn.accept(channel, transformBrickletMultiTouchV2Electrode5Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletMultiTouchV2Electrode6": {
                   BrickletMultiTouchV2ElectrodeConfig channelCfg = channelConfig.as(BrickletMultiTouchV2ElectrodeConfig.class);
                   {
            boolean[] value = this.getTouchState();
            if(true)
                updateStateFn.accept(channel, transformBrickletMultiTouchV2Electrode6Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletMultiTouchV2Electrode7": {
                   BrickletMultiTouchV2ElectrodeConfig channelCfg = channelConfig.as(BrickletMultiTouchV2ElectrodeConfig.class);
                   {
            boolean[] value = this.getTouchState();
            if(true)
                updateStateFn.accept(channel, transformBrickletMultiTouchV2Electrode7Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletMultiTouchV2Electrode8": {
                   BrickletMultiTouchV2ElectrodeConfig channelCfg = channelConfig.as(BrickletMultiTouchV2ElectrodeConfig.class);
                   {
            boolean[] value = this.getTouchState();
            if(true)
                updateStateFn.accept(channel, transformBrickletMultiTouchV2Electrode8Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletMultiTouchV2Electrode9": {
                   BrickletMultiTouchV2ElectrodeConfig channelCfg = channelConfig.as(BrickletMultiTouchV2ElectrodeConfig.class);
                   {
            boolean[] value = this.getTouchState();
            if(true)
                updateStateFn.accept(channel, transformBrickletMultiTouchV2Electrode9Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletMultiTouchV2Electrode10": {
                   BrickletMultiTouchV2ElectrodeConfig channelCfg = channelConfig.as(BrickletMultiTouchV2ElectrodeConfig.class);
                   {
            boolean[] value = this.getTouchState();
            if(true)
                updateStateFn.accept(channel, transformBrickletMultiTouchV2Electrode10Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletMultiTouchV2Electrode11": {
                   BrickletMultiTouchV2ElectrodeConfig channelCfg = channelConfig.as(BrickletMultiTouchV2ElectrodeConfig.class);
                   {
            boolean[] value = this.getTouchState();
            if(true)
                updateStateFn.accept(channel, transformBrickletMultiTouchV2Electrode11Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletMultiTouchV2Proximity": {
                   BrickletMultiTouchV2ElectrodeConfig channelCfg = channelConfig.as(BrickletMultiTouchV2ElectrodeConfig.class);
                   {
            boolean[] value = this.getTouchState();
            if(true)
                updateStateFn.accept(channel, transformBrickletMultiTouchV2ProximityGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletMultiTouchV2Recalibrate":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletMultiTouchV2Config cfg = (BrickletMultiTouchV2Config) config.as(BrickletMultiTouchV2Config.class);
        switch(channel) {
            case "BrickletMultiTouchV2Recalibrate":
                if (command instanceof StringType) {
                    BrickletMultiTouchV2RecalibrateConfig channelCfg = channelConfig.as(BrickletMultiTouchV2RecalibrateConfig.class);
                    StringType cmd = (StringType) command;
                    this.recalibrate();
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode0Callback0(boolean[] state, BrickletMultiTouchV2Config cfg) {
        return state[0] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode1Callback0(boolean[] state, BrickletMultiTouchV2Config cfg) {
        return state[1] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode2Callback0(boolean[] state, BrickletMultiTouchV2Config cfg) {
        return state[2] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode3Callback0(boolean[] state, BrickletMultiTouchV2Config cfg) {
        return state[3] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode4Callback0(boolean[] state, BrickletMultiTouchV2Config cfg) {
        return state[4] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode5Callback0(boolean[] state, BrickletMultiTouchV2Config cfg) {
        return state[5] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode6Callback0(boolean[] state, BrickletMultiTouchV2Config cfg) {
        return state[6] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode7Callback0(boolean[] state, BrickletMultiTouchV2Config cfg) {
        return state[7] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode8Callback0(boolean[] state, BrickletMultiTouchV2Config cfg) {
        return state[8] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode9Callback0(boolean[] state, BrickletMultiTouchV2Config cfg) {
        return state[9] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode10Callback0(boolean[] state, BrickletMultiTouchV2Config cfg) {
        return state[10] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode11Callback0(boolean[] state, BrickletMultiTouchV2Config cfg) {
        return state[11] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2ProximityCallback0(boolean[] state, BrickletMultiTouchV2Config cfg) {
        return state[12] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode0Getter0(boolean[] value, BrickletMultiTouchV2Config cfg) {
        return value[0] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode1Getter0(boolean[] value, BrickletMultiTouchV2Config cfg) {
        return value[1] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode2Getter0(boolean[] value, BrickletMultiTouchV2Config cfg) {
        return value[2] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode3Getter0(boolean[] value, BrickletMultiTouchV2Config cfg) {
        return value[3] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode4Getter0(boolean[] value, BrickletMultiTouchV2Config cfg) {
        return value[4] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode5Getter0(boolean[] value, BrickletMultiTouchV2Config cfg) {
        return value[5] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode6Getter0(boolean[] value, BrickletMultiTouchV2Config cfg) {
        return value[6] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode7Getter0(boolean[] value, BrickletMultiTouchV2Config cfg) {
        return value[7] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode8Getter0(boolean[] value, BrickletMultiTouchV2Config cfg) {
        return value[8] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode9Getter0(boolean[] value, BrickletMultiTouchV2Config cfg) {
        return value[9] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode10Getter0(boolean[] value, BrickletMultiTouchV2Config cfg) {
        return value[10] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2Electrode11Getter0(boolean[] value, BrickletMultiTouchV2Config cfg) {
        return value[11] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMultiTouchV2ProximityGetter0(boolean[] value, BrickletMultiTouchV2Config cfg) {
        return value[12] ? OnOffType.ON : OnOffType.OFF;
    }
}
