/* ***********************************************************
 * This file was automatically generated on 2020-01-23.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;
import com.tinkerforge.Helper;

/**
 * 1.68cm (0.66") OLED display with 64x48 pixels
 */
public class BrickletOLED64x48 extends Device {
	public final static int DEVICE_IDENTIFIER = 264;
	public final static String DEVICE_DISPLAY_NAME = "OLED 64x48 Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletoled64x48", DEVICE_IDENTIFIER, BrickletOLED64x48.class, BrickletOLED64x48Actions.class, "2.0.0");

	public final static byte FUNCTION_WRITE = (byte)1;
	public final static byte FUNCTION_NEW_WINDOW = (byte)2;
	public final static byte FUNCTION_CLEAR_DISPLAY = (byte)3;
	public final static byte FUNCTION_SET_DISPLAY_CONFIGURATION = (byte)4;
	public final static byte FUNCTION_GET_DISPLAY_CONFIGURATION = (byte)5;
	public final static byte FUNCTION_WRITE_LINE = (byte)6;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;



	public class DisplayConfiguration {
		public short contrast;
		public boolean invert;

		public String toString() {
			return "[" + "contrast = " + contrast + ", " + "invert = " + invert + "]";
		}
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletOLED64x48(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_NEW_WINDOW)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_CLEAR_DISPLAY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DISPLAY_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DISPLAY_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_LINE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
	}

	/**
	 * Appends 64 byte of data to the window as set by {@link BrickletOLED64x48#newWindow(short, short, short, short)}.
	 * 
	 * Each row has a height of 8 pixels which corresponds to one byte of data.
	 * 
	 * Example: if you call {@link BrickletOLED64x48#newWindow(short, short, short, short)} with column from 0 to 63 and row
	 * from 0 to 5 (the whole display) each call of {@link BrickletOLED64x48#write(short[])} (red arrow) will
	 * write one row.
	 * 
	 * .. image:: /Images/Bricklets/bricklet_oled_64x48_display.png
	 *    :scale: 100 %
	 *    :alt: Display pixel order
	 *    :align: center
	 *    :target: ../../_images/Bricklets/bricklet_oled_64x48_display.png
	 * 
	 * The LSB (D0) of each data byte is at the top and the MSB (D7) is at the
	 * bottom of the row.
	 * 
	 * The next call of {@link BrickletOLED64x48#write(short[])} will write the second row and so on. To
	 * fill the whole display you need to call {@link BrickletOLED64x48#write(short[])} 6 times.
	 */
	public void write(short[] data) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Sets the window in which you can write with {@link BrickletOLED64x48#write(short[])}. One row
	 * has a height of 8 pixels.
	 */
	public void newWindow(short columnFrom, short columnTo, short rowFrom, short rowTo) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_NEW_WINDOW, this);

		bb.put((byte)columnFrom);
		bb.put((byte)columnTo);
		bb.put((byte)rowFrom);
		bb.put((byte)rowTo);

		sendRequest(bb.array());
	}

	/**
	 * Clears the current content of the window as set by {@link BrickletOLED64x48#newWindow(short, short, short, short)}.
	 */
	public void clearDisplay() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_CLEAR_DISPLAY, this);


		sendRequest(bb.array());
	}

	/**
	 * Sets the configuration of the display.
	 * 
	 * You can set a contrast value from 0 to 255 and you can invert the color
	 * (black/white) of the display.
	 */
	public void setDisplayConfiguration(short contrast, boolean invert) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_DISPLAY_CONFIGURATION, this);

		bb.put((byte)contrast);
		bb.put((byte)(invert ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletOLED64x48#setDisplayConfiguration(short, boolean)}.
	 */
	public DisplayConfiguration getDisplayConfiguration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DISPLAY_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		DisplayConfiguration obj = new DisplayConfiguration();
		obj.contrast = IPConnection.unsignedByte(bb.get());
		obj.invert = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Writes text to a specific line with a specific position.
	 * The text can have a maximum of 13 characters.
	 * 
	 * For example: (1, 4, "Hello") will write *Hello* in the middle of the
	 * second line of the display.
	 * 
	 * You can draw to the display with {@link BrickletOLED64x48#write(short[])} and then add text to it
	 * afterwards.
	 * 
	 * The display uses a special 5x7 pixel charset. You can view the characters
	 * of the charset in Brick Viewer.
	 */
	public void writeLine(short line, short position, String text) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)23, FUNCTION_WRITE_LINE, this);

		bb.put((byte)line);
		bb.put((byte)position);
		for (int i = 0; i < 13; i++) {
			try {
				bb.put((byte)text.charAt(i));
			} catch(Exception e) {
				bb.put((byte)0);
			}
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletOLED64x48.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletOLED64x48.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletOLED64x48Config cfg = (BrickletOLED64x48Config) config.as(BrickletOLED64x48Config.class);
        
        this.setDisplayConfiguration(cfg.contrast.shortValue(), cfg.invert);
		{
		BrickletOLED64x48TextConfig channelCfg = getChannelConfigFn.apply("BrickletOLED64x48Text").as(BrickletOLED64x48TextConfig.class);
		
		}
		{
		BrickletOLED64x48ClearDisplayConfig channelCfg = getChannelConfigFn.apply("BrickletOLED64x48ClearDisplay").as(BrickletOLED64x48ClearDisplayConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletOLED64x48Config cfg = (BrickletOLED64x48Config) config.as(BrickletOLED64x48Config.class);
        
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletOLED64x48Config cfg = (BrickletOLED64x48Config) config.as(BrickletOLED64x48Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletOLED64x48Text");
		result.add("BrickletOLED64x48ClearDisplay");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletOLED64x48Text":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletOLED64x48Text"), "Text", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletOLED64x48Text")).withDescription("Text to display on the LCD. Command format is [line],[position],[text].<br/><br/>Additional ',' are handled as part of the text. Unicode characters are converted to the LCD character set if possible. Additionally you can use \\x[two hex digits] to use a character of the LCD character set directly.").build();
            case "BrickletOLED64x48ClearDisplay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletOLED64x48ClearDisplay"), "Clear Display", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletOLED64x48ClearDisplay")).withDescription("Deletes all characters from the display.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("CLEAR", "Clear")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge OLED 64x48 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("1.68cm (0.66\") OLED display with 64x48 pixels").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletOLED64x48Text", new ChannelTypeUID("tinkerforge", "BrickletOLED64x48Text")).withLabel("Text").build(), new ChannelDefinitionBuilder("BrickletOLED64x48ClearDisplay", new ChannelTypeUID("tinkerforge", "BrickletOLED64x48ClearDisplay")).withLabel("Clear Display").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletoled64x48":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("contrast", Type.INTEGER).withDefault("143").withDescription("Sets the contrast of the display (0-255).").withLabel("Contrast").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(255)).build(), ConfigDescriptionParameterBuilder.create("invert", Type.BOOLEAN).withDefault("false").withDescription("Inverts the color (black/white) of the display.").withLabel("Invert").withAdvanced(true).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletOLED64x48Text":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletOLED64x48ClearDisplay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletOLED64x48Config cfg = (BrickletOLED64x48Config) config.as(BrickletOLED64x48Config.class);
        switch(channel) {
            case "BrickletOLED64x48Text":
               return;
            case "BrickletOLED64x48ClearDisplay":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletOLED64x48Config cfg = (BrickletOLED64x48Config) config.as(BrickletOLED64x48Config.class);
        switch(channel) {
            case "BrickletOLED64x48Text":
                if (command instanceof StringType) {
                    BrickletOLED64x48TextConfig channelCfg = channelConfig.as(BrickletOLED64x48TextConfig.class);
                    StringType cmd = (StringType) command;
                    this.writeLine(Helper.parseDisplayCommandLine(cmd.toString(), logger), Helper.parseDisplayCommandPosition(cmd.toString(), logger), Helper.parseDisplayCommandText(cmd.toString(), logger, false));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletOLED64x48ClearDisplay":
                if (command instanceof StringType) {
                    BrickletOLED64x48ClearDisplayConfig channelCfg = channelConfig.as(BrickletOLED64x48ClearDisplayConfig.class);
                    StringType cmd = (StringType) command;
                    this.clearDisplay();
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

    
}
