/* ***********************************************************
 * This file was automatically generated on 2020-01-23.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

/**
 * Measures contactless object temperature between -70°C and +380°C
 */
public class BrickletTemperatureIR extends Device {
	public final static int DEVICE_IDENTIFIER = 217;
	public final static String DEVICE_DISPLAY_NAME = "Temperature IR Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "bricklettemperatureir", DEVICE_IDENTIFIER, BrickletTemperatureIR.class, BrickletTemperatureIRActions.class, "2.0.4");

	public final static byte FUNCTION_GET_AMBIENT_TEMPERATURE = (byte)1;
	public final static byte FUNCTION_GET_OBJECT_TEMPERATURE = (byte)2;
	public final static byte FUNCTION_SET_EMISSIVITY = (byte)3;
	public final static byte FUNCTION_GET_EMISSIVITY = (byte)4;
	public final static byte FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD = (byte)5;
	public final static byte FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD = (byte)6;
	public final static byte FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_PERIOD = (byte)7;
	public final static byte FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD = (byte)8;
	public final static byte FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD = (byte)9;
	public final static byte FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD = (byte)10;
	public final static byte FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD = (byte)11;
	public final static byte FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD = (byte)12;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)13;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)14;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_AMBIENT_TEMPERATURE = 15;
	private final static int CALLBACK_OBJECT_TEMPERATURE = 16;
	private final static int CALLBACK_AMBIENT_TEMPERATURE_REACHED = 17;
	private final static int CALLBACK_OBJECT_TEMPERATURE_REACHED = 18;

	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';

	private List<AmbientTemperatureListener> listenerAmbientTemperature = new CopyOnWriteArrayList<AmbientTemperatureListener>();
	private List<ObjectTemperatureListener> listenerObjectTemperature = new CopyOnWriteArrayList<ObjectTemperatureListener>();
	private List<AmbientTemperatureReachedListener> listenerAmbientTemperatureReached = new CopyOnWriteArrayList<AmbientTemperatureReachedListener>();
	private List<ObjectTemperatureReachedListener> listenerObjectTemperatureReached = new CopyOnWriteArrayList<ObjectTemperatureReachedListener>();

	public class AmbientTemperatureCallbackThreshold {
		public char option;
		public short min;
		public short max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class ObjectTemperatureCallbackThreshold {
		public char option;
		public short min;
		public short max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletTemperatureIR#setAmbientTemperatureCallbackPeriod(long)}. The parameter is the
	 * ambient temperature of the sensor.
	 * 
	 * The {@link BrickletTemperatureIR.AmbientTemperatureListener} listener is only triggered if the ambient
	 * temperature has changed since the last triggering.
	 */
	public interface AmbientTemperatureListener extends DeviceListener {
		public void ambientTemperature(short temperature);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletTemperatureIR#setObjectTemperatureCallbackPeriod(long)}. The parameter is the
	 * object temperature of the sensor.
	 * 
	 * The {@link BrickletTemperatureIR.ObjectTemperatureListener} listener is only triggered if the object
	 * temperature has changed since the last triggering.
	 */
	public interface ObjectTemperatureListener extends DeviceListener {
		public void objectTemperature(short temperature);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link BrickletTemperatureIR#setAmbientTemperatureCallbackThreshold(char, short, short)} is reached.
	 * The parameter is the ambient temperature of the sensor.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link BrickletTemperatureIR#setDebouncePeriod(long)}.
	 */
	public interface AmbientTemperatureReachedListener extends DeviceListener {
		public void ambientTemperatureReached(short temperature);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link BrickletTemperatureIR#setObjectTemperatureCallbackThreshold(char, short, short)} is reached.
	 * The parameter is the object temperature of the sensor.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link BrickletTemperatureIR#setDebouncePeriod(long)}.
	 */
	public interface ObjectTemperatureReachedListener extends DeviceListener {
		public void objectTemperatureReached(short temperature);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletTemperatureIR(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_AMBIENT_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_OBJECT_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_EMISSIVITY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EMISSIVITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_AMBIENT_TEMPERATURE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short temperature = (bb.getShort());

				for (AmbientTemperatureListener listener: listenerAmbientTemperature) {
					listener.ambientTemperature(temperature);
				}
			}
		};

		callbacks[CALLBACK_OBJECT_TEMPERATURE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short temperature = (bb.getShort());

				for (ObjectTemperatureListener listener: listenerObjectTemperature) {
					listener.objectTemperature(temperature);
				}
			}
		};

		callbacks[CALLBACK_AMBIENT_TEMPERATURE_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short temperature = (bb.getShort());

				for (AmbientTemperatureReachedListener listener: listenerAmbientTemperatureReached) {
					listener.ambientTemperatureReached(temperature);
				}
			}
		};

		callbacks[CALLBACK_OBJECT_TEMPERATURE_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short temperature = (bb.getShort());

				for (ObjectTemperatureReachedListener listener: listenerObjectTemperatureReached) {
					listener.objectTemperatureReached(temperature);
				}
			}
		};
	}

	/**
	 * Returns the ambient temperature of the sensor.
	 * 
	 * If you want to get the ambient temperature periodically, it is recommended
	 * to use the {@link BrickletTemperatureIR.AmbientTemperatureListener} listener and set the period with
	 * {@link BrickletTemperatureIR#setAmbientTemperatureCallbackPeriod(long)}.
	 */
	public short getAmbientTemperature() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AMBIENT_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Returns the object temperature of the sensor, i.e. the temperature
	 * of the surface of the object the sensor is aimed at.
	 * 
	 * The temperature of different materials is dependent on their `emissivity
	 * &lt;https://en.wikipedia.org/wiki/Emissivity&gt;`__. The emissivity of the material
	 * can be set with {@link BrickletTemperatureIR#setEmissivity(int)}.
	 * 
	 * If you want to get the object temperature periodically, it is recommended
	 * to use the {@link BrickletTemperatureIR.ObjectTemperatureListener} listener and set the period with
	 * {@link BrickletTemperatureIR#setObjectTemperatureCallbackPeriod(long)}.
	 */
	public short getObjectTemperature() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_OBJECT_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Sets the `emissivity &lt;https://en.wikipedia.org/wiki/Emissivity&gt;`__ that is
	 * used to calculate the surface temperature as returned by
	 * {@link BrickletTemperatureIR#getObjectTemperature()}.
	 * 
	 * The emissivity is usually given as a value between 0.0 and 1.0. A list of
	 * emissivities of different materials can be found
	 * `here &lt;https://www.infrared-thermography.com/material.htm&gt;`__.
	 * 
	 * The parameter of {@link BrickletTemperatureIR#setEmissivity(int)} has to be given with a factor of
	 * 65535 (16-bit). For example: An emissivity of 0.1 can be set with the
	 * value 6553, an emissivity of 0.5 with the value 32767 and so on.
	 * 
	 * \note
	 *  If you need a precise measurement for the object temperature, it is
	 *  absolutely crucial that you also provide a precise emissivity.
	 * 
	 * The emissivity is stored in non-volatile memory and will still be used after a restart or power cycle of the Bricklet.
	 */
	public void setEmissivity(int emissivity) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_EMISSIVITY, this);

		bb.putShort((short)emissivity);

		sendRequest(bb.array());
	}

	/**
	 * Returns the emissivity as set by {@link BrickletTemperatureIR#setEmissivity(int)}.
	 */
	public int getEmissivity() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_EMISSIVITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int emissivity = IPConnection.unsignedShort(bb.getShort());

		return emissivity;
	}

	/**
	 * Sets the period with which the {@link BrickletTemperatureIR.AmbientTemperatureListener} listener is
	 * triggered periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletTemperatureIR.AmbientTemperatureListener} listener is only triggered if the temperature has
	 * changed since the last triggering.
	 */
	public void setAmbientTemperatureCallbackPeriod(long period) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletTemperatureIR#setAmbientTemperatureCallbackPeriod(long)}.
	 */
	public long getAmbientTemperatureCallbackPeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickletTemperatureIR.ObjectTemperatureListener} listener is
	 * triggered periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletTemperatureIR.ObjectTemperatureListener} listener is only triggered if the temperature
	 * has changed since the last triggering.
	 */
	public void setObjectTemperatureCallbackPeriod(long period) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletTemperatureIR#setObjectTemperatureCallbackPeriod(long)}.
	 */
	public long getObjectTemperatureCallbackPeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the thresholds for the {@link BrickletTemperatureIR.AmbientTemperatureReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the ambient temperature is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the ambient temperature is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the ambient temperature is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the ambient temperature is greater than the min value (max is ignored)"
	 * \endverbatim
	 */
	public void setAmbientTemperatureCallbackThreshold(char option, short min, short max) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD, this);

		bb.put((byte)option);
		bb.putShort(min);
		bb.putShort(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link BrickletTemperatureIR#setAmbientTemperatureCallbackThreshold(char, short, short)}.
	 */
	public AmbientTemperatureCallbackThreshold getAmbientTemperatureCallbackThreshold() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AmbientTemperatureCallbackThreshold obj = new AmbientTemperatureCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = (bb.getShort());
		obj.max = (bb.getShort());

		return obj;
	}

	/**
	 * Sets the thresholds for the {@link BrickletTemperatureIR.ObjectTemperatureReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the object temperature is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the object temperature is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the object temperature is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the object temperature is greater than the min value (max is ignored)"
	 * \endverbatim
	 */
	public void setObjectTemperatureCallbackThreshold(char option, short min, short max) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD, this);

		bb.put((byte)option);
		bb.putShort(min);
		bb.putShort(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link BrickletTemperatureIR#setObjectTemperatureCallbackThreshold(char, short, short)}.
	 */
	public ObjectTemperatureCallbackThreshold getObjectTemperatureCallbackThreshold() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ObjectTemperatureCallbackThreshold obj = new ObjectTemperatureCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = (bb.getShort());
		obj.max = (bb.getShort());

		return obj;
	}

	/**
	 * Sets the period with which the threshold listeners
	 * 
	 * * {@link BrickletTemperatureIR.AmbientTemperatureReachedListener},
	 * * {@link BrickletTemperatureIR.ObjectTemperatureReachedListener}
	 * 
	 * are triggered, if the thresholds
	 * 
	 * * {@link BrickletTemperatureIR#setAmbientTemperatureCallbackThreshold(char, short, short)},
	 * * {@link BrickletTemperatureIR#setObjectTemperatureCallbackThreshold(char, short, short)}
	 * 
	 * keep being reached.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the debounce period as set by {@link BrickletTemperatureIR#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnection.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a AmbientTemperature listener.
	 */
	public void addAmbientTemperatureListener(AmbientTemperatureListener listener) {
		listenerAmbientTemperature.add(listener);
	}

	/**
	 * Removes a AmbientTemperature listener.
	 */
	public void removeAmbientTemperatureListener(AmbientTemperatureListener listener) {
		listenerAmbientTemperature.remove(listener);
	}

	/**
	 * Adds a ObjectTemperature listener.
	 */
	public void addObjectTemperatureListener(ObjectTemperatureListener listener) {
		listenerObjectTemperature.add(listener);
	}

	/**
	 * Removes a ObjectTemperature listener.
	 */
	public void removeObjectTemperatureListener(ObjectTemperatureListener listener) {
		listenerObjectTemperature.remove(listener);
	}

	/**
	 * Adds a AmbientTemperatureReached listener.
	 */
	public void addAmbientTemperatureReachedListener(AmbientTemperatureReachedListener listener) {
		listenerAmbientTemperatureReached.add(listener);
	}

	/**
	 * Removes a AmbientTemperatureReached listener.
	 */
	public void removeAmbientTemperatureReachedListener(AmbientTemperatureReachedListener listener) {
		listenerAmbientTemperatureReached.remove(listener);
	}

	/**
	 * Adds a ObjectTemperatureReached listener.
	 */
	public void addObjectTemperatureReachedListener(ObjectTemperatureReachedListener listener) {
		listenerObjectTemperatureReached.add(listener);
	}

	/**
	 * Removes a ObjectTemperatureReached listener.
	 */
	public void removeObjectTemperatureReachedListener(ObjectTemperatureReachedListener listener) {
		listenerObjectTemperatureReached.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletTemperatureIR.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletTemperatureIR.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletTemperatureIRConfig cfg = (BrickletTemperatureIRConfig) config.as(BrickletTemperatureIRConfig.class);
        this.addAmbientTemperatureListener((temperature) -> {if(true) {updateStateFn.accept("BrickletTemperatureIRAmbientTemperature", transformBrickletTemperatureIRAmbientTemperatureCallback0(temperature, cfg));}});
		this.addObjectTemperatureListener((temperature) -> {if(true) {updateStateFn.accept("BrickletTemperatureIRObjectTemperature", transformBrickletTemperatureIRObjectTemperatureCallback0(temperature, cfg));}});
        
		{
		BrickletTemperatureIRAmbientTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletTemperatureIRAmbientTemperature").as(BrickletTemperatureIRAmbientTemperatureConfig.class);
		this.setAmbientTemperatureCallbackPeriod(channelCfg.updateInterval);
		this.setAmbientTemperatureCallbackThreshold('x', (short)0, (short)0);
		}
		{
		BrickletTemperatureIRObjectTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletTemperatureIRObjectTemperature").as(BrickletTemperatureIRObjectTemperatureConfig.class);
		this.setObjectTemperatureCallbackPeriod(channelCfg.updateInterval);
		this.setObjectTemperatureCallbackThreshold('x', (short)0, (short)0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletTemperatureIRConfig cfg = (BrickletTemperatureIRConfig) config.as(BrickletTemperatureIRConfig.class);
        this.listenerAmbientTemperature.clear();
		this.listenerObjectTemperature.clear();
        this.setAmbientTemperatureCallbackPeriod(0);
		this.setObjectTemperatureCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletTemperatureIRConfig cfg = (BrickletTemperatureIRConfig) config.as(BrickletTemperatureIRConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletTemperatureIRAmbientTemperature");
		result.add("BrickletTemperatureIRObjectTemperature");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletTemperatureIRAmbientTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletTemperatureIRAmbientTemperature"), "Ambient Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletTemperatureIRAmbientTemperature")).withDescription("Measured ambient temperature")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-40)).withMaximum(BigDecimal.valueOf(125)).withPattern("%.1f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletTemperatureIRObjectTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletTemperatureIRObjectTemperature"), "Object Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletTemperatureIRObjectTemperature")).withDescription("Measured object temperature, i.e. the temperature of the surface of the object the sensor is aimed at. The temperature of different materials is dependent on their <a href=https://en.wikipedia.org/wiki/Emissivity>emissivity</a>.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-70)).withMaximum(BigDecimal.valueOf(380)).withPattern("%.1f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Temperature IR Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures contactless object temperature between -70°C and +380°C").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletTemperatureIRAmbientTemperature", new ChannelTypeUID("tinkerforge", "BrickletTemperatureIRAmbientTemperature")).withLabel("Ambient Temperature").build(), new ChannelDefinitionBuilder("BrickletTemperatureIRObjectTemperature", new ChannelTypeUID("tinkerforge", "BrickletTemperatureIRObjectTemperature")).withLabel("Object Temperature").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:bricklettemperatureir":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletTemperatureIRAmbientTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletTemperatureIRObjectTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletTemperatureIRConfig cfg = (BrickletTemperatureIRConfig) config.as(BrickletTemperatureIRConfig.class);
        switch(channel) {
            case "BrickletTemperatureIRAmbientTemperature": {
                   BrickletTemperatureIRAmbientTemperatureConfig channelCfg = channelConfig.as(BrickletTemperatureIRAmbientTemperatureConfig.class);
                   {
            short value = this.getAmbientTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletTemperatureIRAmbientTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletTemperatureIRObjectTemperature": {
                   BrickletTemperatureIRObjectTemperatureConfig channelCfg = channelConfig.as(BrickletTemperatureIRObjectTemperatureConfig.class);
                   {
            short value = this.getObjectTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletTemperatureIRObjectTemperatureGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletTemperatureIRConfig cfg = (BrickletTemperatureIRConfig) config.as(BrickletTemperatureIRConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletTemperatureIRAmbientTemperatureCallback0(short temperature, BrickletTemperatureIRConfig cfg) {
        return new QuantityType<>(temperature / 10.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletTemperatureIRObjectTemperatureCallback0(short temperature, BrickletTemperatureIRConfig cfg) {
        return new QuantityType<>(temperature / 10.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletTemperatureIRAmbientTemperatureGetter0(short value, BrickletTemperatureIRConfig cfg) {
        return new QuantityType<>(value / 10.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletTemperatureIRObjectTemperatureGetter0(short value, BrickletTemperatureIRConfig cfg) {
        return new QuantityType<>(value / 10.0, SIUnits.CELSIUS);
    }
}
