/* ***********************************************************
 * This file was automatically generated on 2020-01-23.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

/**
 * Measures temperature with thermocouples
 */
public class BrickletThermocouple extends Device {
	public final static int DEVICE_IDENTIFIER = 266;
	public final static String DEVICE_DISPLAY_NAME = "Thermocouple Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletthermocouple", DEVICE_IDENTIFIER, BrickletThermocouple.class, BrickletThermocoupleActions.class, "2.0.1");

	public final static byte FUNCTION_GET_TEMPERATURE = (byte)1;
	public final static byte FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD = (byte)2;
	public final static byte FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD = (byte)3;
	public final static byte FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD = (byte)4;
	public final static byte FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD = (byte)5;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)6;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)7;
	public final static byte FUNCTION_SET_CONFIGURATION = (byte)10;
	public final static byte FUNCTION_GET_CONFIGURATION = (byte)11;
	public final static byte FUNCTION_GET_ERROR_STATE = (byte)12;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_TEMPERATURE = 8;
	private final static int CALLBACK_TEMPERATURE_REACHED = 9;
	private final static int CALLBACK_ERROR_STATE = 13;

	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static short AVERAGING_1 = (short)1;
	public final static short AVERAGING_2 = (short)2;
	public final static short AVERAGING_4 = (short)4;
	public final static short AVERAGING_8 = (short)8;
	public final static short AVERAGING_16 = (short)16;
	public final static short TYPE_B = (short)0;
	public final static short TYPE_E = (short)1;
	public final static short TYPE_J = (short)2;
	public final static short TYPE_K = (short)3;
	public final static short TYPE_N = (short)4;
	public final static short TYPE_R = (short)5;
	public final static short TYPE_S = (short)6;
	public final static short TYPE_T = (short)7;
	public final static short TYPE_G8 = (short)8;
	public final static short TYPE_G32 = (short)9;
	public final static short FILTER_OPTION_50HZ = (short)0;
	public final static short FILTER_OPTION_60HZ = (short)1;

	private List<TemperatureListener> listenerTemperature = new CopyOnWriteArrayList<TemperatureListener>();
	private List<TemperatureReachedListener> listenerTemperatureReached = new CopyOnWriteArrayList<TemperatureReachedListener>();
	private List<ErrorStateListener> listenerErrorState = new CopyOnWriteArrayList<ErrorStateListener>();

	public class TemperatureCallbackThreshold {
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class Configuration {
		public short averaging;
		public short thermocoupleType;
		public short filter;

		public String toString() {
			return "[" + "averaging = " + averaging + ", " + "thermocoupleType = " + thermocoupleType + ", " + "filter = " + filter + "]";
		}
	}

	public class ErrorState {
		public boolean overUnder;
		public boolean openCircuit;

		public String toString() {
			return "[" + "overUnder = " + overUnder + ", " + "openCircuit = " + openCircuit + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletThermocouple#setTemperatureCallbackPeriod(long)}. The parameter is the
	 * temperature of the thermocouple.
	 * 
	 * The {@link BrickletThermocouple.TemperatureListener} listener is only triggered if the temperature has
	 * changed since the last triggering.
	 */
	public interface TemperatureListener extends DeviceListener {
		public void temperature(int temperature);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link BrickletThermocouple#setTemperatureCallbackThreshold(char, int, int)} is reached.
	 * The parameter is the temperature of the thermocouple.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link BrickletThermocouple#setDebouncePeriod(long)}.
	 */
	public interface TemperatureReachedListener extends DeviceListener {
		public void temperatureReached(int temperature);
	}

	/**
	 * This Listener is triggered every time the error state changes
	 * (see {@link BrickletThermocouple#getErrorState()}).
	 */
	public interface ErrorStateListener extends DeviceListener {
		public void errorState(boolean overUnder, boolean openCircuit);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletThermocouple(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ERROR_STATE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_TEMPERATURE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int temperature = (bb.getInt());

				for (TemperatureListener listener: listenerTemperature) {
					listener.temperature(temperature);
				}
			}
		};

		callbacks[CALLBACK_TEMPERATURE_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int temperature = (bb.getInt());

				for (TemperatureReachedListener listener: listenerTemperatureReached) {
					listener.temperatureReached(temperature);
				}
			}
		};

		callbacks[CALLBACK_ERROR_STATE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				boolean overUnder = (bb.get()) != 0;
				boolean openCircuit = (bb.get()) != 0;

				for (ErrorStateListener listener: listenerErrorState) {
					listener.errorState(overUnder, openCircuit);
				}
			}
		};
	}

	/**
	 * Returns the temperature of the thermocouple.
	 * 
	 * If you want to get the temperature periodically, it is recommended
	 * to use the {@link BrickletThermocouple.TemperatureListener} listener and set the period with
	 * {@link BrickletThermocouple#setTemperatureCallbackPeriod(long)}.
	 */
	public int getTemperature() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getInt());

		return temperature;
	}

	/**
	 * Sets the period with which the {@link BrickletThermocouple.TemperatureListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletThermocouple.TemperatureListener} listener is only triggered if the temperature has changed
	 * since the last triggering.
	 */
	public void setTemperatureCallbackPeriod(long period) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletThermocouple#setTemperatureCallbackPeriod(long)}.
	 */
	public long getTemperatureCallbackPeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the thresholds for the {@link BrickletThermocouple.TemperatureReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the temperature is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the temperature is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the temperature is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the temperature is greater than the min value (max is ignored)"
	 * \endverbatim
	 */
	public void setTemperatureCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)17, FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD, this);

		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link BrickletThermocouple#setTemperatureCallbackThreshold(char, int, int)}.
	 */
	public TemperatureCallbackThreshold getTemperatureCallbackThreshold() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		TemperatureCallbackThreshold obj = new TemperatureCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the period with which the threshold listener
	 * 
	 * * {@link BrickletThermocouple.TemperatureReachedListener}
	 * 
	 * is triggered, if the threshold
	 * 
	 * * {@link BrickletThermocouple#setTemperatureCallbackThreshold(char, int, int)}
	 * 
	 * keeps being reached.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the debounce period as set by {@link BrickletThermocouple#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnection.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * You can configure averaging size, thermocouple type and frequency
	 * filtering.
	 * 
	 * Available averaging sizes are 1, 2, 4, 8 and 16 samples.
	 * 
	 * As thermocouple type you can use B, E, J, K, N, R, S and T. If you have a
	 * different thermocouple or a custom thermocouple you can also use
	 * G8 and G32. With these types the returned value will not be in °C/100,
	 * it will be calculated by the following formulas:
	 * 
	 * * G8: ``value = 8 * 1.6 * 2^17 * Vin``
	 * * G32: ``value = 32 * 1.6 * 2^17 * Vin``
	 * 
	 * where Vin is the thermocouple input voltage.
	 * 
	 * The frequency filter can be either configured to 50Hz or to 60Hz. You should
	 * configure it according to your utility frequency.
	 * 
	 * The conversion time depends on the averaging and filter configuration, it can
	 * be calculated as follows:
	 * 
	 * * 60Hz: ``time = 82 + (samples - 1) * 16.67``
	 * * 50Hz: ``time = 98 + (samples - 1) * 20``
	 */
	public void setConfiguration(short averaging, short thermocoupleType, short filter) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SET_CONFIGURATION, this);

		bb.put((byte)averaging);
		bb.put((byte)thermocoupleType);
		bb.put((byte)filter);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletThermocouple#setConfiguration(short, short, short)}.
	 */
	public Configuration getConfiguration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.averaging = IPConnection.unsignedByte(bb.get());
		obj.thermocoupleType = IPConnection.unsignedByte(bb.get());
		obj.filter = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the current error state. There are two possible errors:
	 * 
	 * * Over/Under Voltage and
	 * * Open Circuit.
	 * 
	 * Over/Under Voltage happens for voltages below 0V or above 3.3V. In this case
	 * it is very likely that your thermocouple is defective. An Open Circuit error
	 * indicates that there is no thermocouple connected.
	 * 
	 * You can use the {@link BrickletThermocouple.ErrorStateListener} listener to automatically get triggered
	 * when the error state changes.
	 */
	public ErrorState getErrorState() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ERROR_STATE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ErrorState obj = new ErrorState();
		obj.overUnder = (bb.get()) != 0;
		obj.openCircuit = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Temperature listener.
	 */
	public void addTemperatureListener(TemperatureListener listener) {
		listenerTemperature.add(listener);
	}

	/**
	 * Removes a Temperature listener.
	 */
	public void removeTemperatureListener(TemperatureListener listener) {
		listenerTemperature.remove(listener);
	}

	/**
	 * Adds a TemperatureReached listener.
	 */
	public void addTemperatureReachedListener(TemperatureReachedListener listener) {
		listenerTemperatureReached.add(listener);
	}

	/**
	 * Removes a TemperatureReached listener.
	 */
	public void removeTemperatureReachedListener(TemperatureReachedListener listener) {
		listenerTemperatureReached.remove(listener);
	}

	/**
	 * Adds a ErrorState listener.
	 */
	public void addErrorStateListener(ErrorStateListener listener) {
		listenerErrorState.add(listener);
	}

	/**
	 * Removes a ErrorState listener.
	 */
	public void removeErrorStateListener(ErrorStateListener listener) {
		listenerErrorState.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletThermocouple.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletThermocouple.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletThermocoupleConfig cfg = (BrickletThermocoupleConfig) config.as(BrickletThermocoupleConfig.class);
        this.addTemperatureListener((temperature) -> {if(true) {updateStateFn.accept("BrickletThermocoupleTemperature", transformBrickletThermocoupleTemperatureCallback0(temperature, cfg));}});
		this.addErrorStateListener((overUnder, openCircuit) -> {if(true) {updateStateFn.accept("BrickletThermocoupleOverUnderVoltage", transformBrickletThermocoupleOverUnderVoltageCallback0(overUnder, openCircuit, cfg));}});
		this.addErrorStateListener((overUnder, openCircuit) -> {if(true) {updateStateFn.accept("BrickletThermocoupleOpenCircuit", transformBrickletThermocoupleOpenCircuitCallback0(overUnder, openCircuit, cfg));}});
        this.setConfiguration(cfg.averageLength.shortValue(), cfg.thermocoupleType.shortValue(), cfg.frequencyFilter.shortValue());
		{
		BrickletThermocoupleTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletThermocoupleTemperature").as(BrickletThermocoupleTemperatureConfig.class);
		this.setTemperatureCallbackPeriod(channelCfg.updateInterval);
		this.setTemperatureCallbackThreshold('x', 0, 0);
		}
		{
		BrickletThermocoupleOverUnderVoltageConfig channelCfg = getChannelConfigFn.apply("BrickletThermocoupleOverUnderVoltage").as(BrickletThermocoupleOverUnderVoltageConfig.class);
		
		}
		{
		BrickletThermocoupleOpenCircuitConfig channelCfg = getChannelConfigFn.apply("BrickletThermocoupleOpenCircuit").as(BrickletThermocoupleOpenCircuitConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletThermocoupleConfig cfg = (BrickletThermocoupleConfig) config.as(BrickletThermocoupleConfig.class);
        this.listenerTemperature.clear();
		this.listenerErrorState.clear();
		this.listenerErrorState.clear();
        this.setTemperatureCallbackPeriod(0);
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletThermocoupleConfig cfg = (BrickletThermocoupleConfig) config.as(BrickletThermocoupleConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletThermocoupleTemperature");
		result.add("BrickletThermocoupleOverUnderVoltage");
		result.add("BrickletThermocoupleOpenCircuit");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletThermocoupleTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletThermocoupleTemperature"), "Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletThermocoupleTemperature")).withDescription("The temperature of the thermocouple.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-210)).withMaximum(BigDecimal.valueOf(1800)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletThermocoupleOverUnderVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletThermocoupleOverUnderVoltage"), "Over/Under Voltage Error", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletThermocoupleOverUnderVoltage")).withDescription("Over/Under Voltage happens for voltages below 0V or above 3.3V. In this case it is very likely that your thermocouple is defective.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletThermocoupleOpenCircuit":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletThermocoupleOpenCircuit"), "Open Circuit Error", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletThermocoupleOpenCircuit")).withDescription("An Open Circuit error indicates that there is no thermocouple connected.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Thermocouple Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures temperature with thermocouples").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletThermocoupleTemperature", new ChannelTypeUID("tinkerforge", "BrickletThermocoupleTemperature")).withLabel("Temperature").build(), new ChannelDefinitionBuilder("BrickletThermocoupleOverUnderVoltage", new ChannelTypeUID("tinkerforge", "BrickletThermocoupleOverUnderVoltage")).withLabel("Over/Under Voltage").build(), new ChannelDefinitionBuilder("BrickletThermocoupleOpenCircuit", new ChannelTypeUID("tinkerforge", "BrickletThermocoupleOpenCircuit")).withLabel("Open Circuit").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletthermocouple":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("averageLength", Type.INTEGER).withDefault("16").withDescription("Available averaging sizes are 1, 2, 4, 8 and 16 samples.<br/><br/>The conversion time depends on the averaging and filter configuration, it can be calculated as follows:<ul><li>60Hz: time = 82 + (samples - 1) * 16.67</li><li>50Hz: time = 98 + (samples - 1) * 20</li></ul>").withLabel("Average Length").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("1", "1"), new ParameterOption("2", "2"), new ParameterOption("4", "4"), new ParameterOption("8", "8"), new ParameterOption("16", "16"))).build(), ConfigDescriptionParameterBuilder.create("thermocoupleType", Type.INTEGER).withDefault("3").withDescription("As thermocouple type you can use B, E, J, K, N, R, S and T. If you have a different thermocouple or a custom thermocouple you can also use G8 and G32. With these types the returned value will not be in °C/100, it will be calculated by the following formulas:<ul><li>G8: value = 8 * 1.6 * 2^17 * Vin</li><li>G32: value = 32 * 1.6 * 2^17 * Vin</li></ul>where Vin is the thermocouple input voltage.").withLabel("Thermocouple Type").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "B"), new ParameterOption("1", "E"), new ParameterOption("2", "J"), new ParameterOption("3", "K"), new ParameterOption("4", "N"), new ParameterOption("5", "R"), new ParameterOption("6", "S"), new ParameterOption("7", "T"), new ParameterOption("8", "G8"), new ParameterOption("9", "G32"))).build(), ConfigDescriptionParameterBuilder.create("frequencyFilter", Type.INTEGER).withDefault("0").withDescription("The frequency filter can be either configured to 50Hz or to 60Hz. You should configure it according to your utility frequency.").withLabel("Frequency Filter").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "50Hz"), new ParameterOption("1", "60Hz"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletThermocoupleTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletThermocoupleOverUnderVoltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletThermocoupleOpenCircuit":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletThermocoupleConfig cfg = (BrickletThermocoupleConfig) config.as(BrickletThermocoupleConfig.class);
        switch(channel) {
            case "BrickletThermocoupleTemperature": {
                   BrickletThermocoupleTemperatureConfig channelCfg = channelConfig.as(BrickletThermocoupleTemperatureConfig.class);
                   {
            int value = this.getTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermocoupleTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermocoupleOverUnderVoltage": {
                   BrickletThermocoupleOverUnderVoltageConfig channelCfg = channelConfig.as(BrickletThermocoupleOverUnderVoltageConfig.class);
                   {
            ErrorState value = this.getErrorState();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermocoupleOverUnderVoltageGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermocoupleOpenCircuit": {
                   BrickletThermocoupleOpenCircuitConfig channelCfg = channelConfig.as(BrickletThermocoupleOpenCircuitConfig.class);
                   {
            ErrorState value = this.getErrorState();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermocoupleOpenCircuitGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletThermocoupleConfig cfg = (BrickletThermocoupleConfig) config.as(BrickletThermocoupleConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletThermocoupleTemperatureCallback0(int temperature, BrickletThermocoupleConfig cfg) {
        return new QuantityType<>(temperature / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermocoupleOverUnderVoltageCallback0(boolean overUnder, boolean openCircuit, BrickletThermocoupleConfig cfg) {
        return overUnder ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermocoupleOpenCircuitCallback0(boolean overUnder, boolean openCircuit, BrickletThermocoupleConfig cfg) {
        return openCircuit ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermocoupleTemperatureGetter0(int value, BrickletThermocoupleConfig cfg) {
        return new QuantityType<>(value / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermocoupleOverUnderVoltageGetter0(ErrorState value, BrickletThermocoupleConfig cfg) {
        return value.overUnder ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermocoupleOpenCircuitGetter0(ErrorState value, BrickletThermocoupleConfig cfg) {
        return value.openCircuit ? OnOffType.ON : OnOffType.OFF;
    }
}
