/* ***********************************************************
 * This file was automatically generated on 2020-01-23.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

/**
 * Measures power, DC voltage and DC current up to 720W/36V/20A
 */
public class BrickletVoltageCurrent extends Device {
	public final static int DEVICE_IDENTIFIER = 227;
	public final static String DEVICE_DISPLAY_NAME = "Voltage/Current Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletvoltagecurrent", DEVICE_IDENTIFIER, BrickletVoltageCurrent.class, BrickletVoltageCurrentActions.class, "2.0.4");

	public final static byte FUNCTION_GET_CURRENT = (byte)1;
	public final static byte FUNCTION_GET_VOLTAGE = (byte)2;
	public final static byte FUNCTION_GET_POWER = (byte)3;
	public final static byte FUNCTION_SET_CONFIGURATION = (byte)4;
	public final static byte FUNCTION_GET_CONFIGURATION = (byte)5;
	public final static byte FUNCTION_SET_CALIBRATION = (byte)6;
	public final static byte FUNCTION_GET_CALIBRATION = (byte)7;
	public final static byte FUNCTION_SET_CURRENT_CALLBACK_PERIOD = (byte)8;
	public final static byte FUNCTION_GET_CURRENT_CALLBACK_PERIOD = (byte)9;
	public final static byte FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD = (byte)10;
	public final static byte FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD = (byte)11;
	public final static byte FUNCTION_SET_POWER_CALLBACK_PERIOD = (byte)12;
	public final static byte FUNCTION_GET_POWER_CALLBACK_PERIOD = (byte)13;
	public final static byte FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD = (byte)14;
	public final static byte FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD = (byte)15;
	public final static byte FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD = (byte)16;
	public final static byte FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD = (byte)17;
	public final static byte FUNCTION_SET_POWER_CALLBACK_THRESHOLD = (byte)18;
	public final static byte FUNCTION_GET_POWER_CALLBACK_THRESHOLD = (byte)19;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)20;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)21;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_CURRENT = 22;
	private final static int CALLBACK_VOLTAGE = 23;
	private final static int CALLBACK_POWER = 24;
	private final static int CALLBACK_CURRENT_REACHED = 25;
	private final static int CALLBACK_VOLTAGE_REACHED = 26;
	private final static int CALLBACK_POWER_REACHED = 27;

	public final static short AVERAGING_1 = (short)0;
	public final static short AVERAGING_4 = (short)1;
	public final static short AVERAGING_16 = (short)2;
	public final static short AVERAGING_64 = (short)3;
	public final static short AVERAGING_128 = (short)4;
	public final static short AVERAGING_256 = (short)5;
	public final static short AVERAGING_512 = (short)6;
	public final static short AVERAGING_1024 = (short)7;
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static short CONVERSION_TIME_140US = (short)0;
	public final static short CONVERSION_TIME_204US = (short)1;
	public final static short CONVERSION_TIME_332US = (short)2;
	public final static short CONVERSION_TIME_588US = (short)3;
	public final static short CONVERSION_TIME_1_1MS = (short)4;
	public final static short CONVERSION_TIME_2_116MS = (short)5;
	public final static short CONVERSION_TIME_4_156MS = (short)6;
	public final static short CONVERSION_TIME_8_244MS = (short)7;

	private List<CurrentListener> listenerCurrent = new CopyOnWriteArrayList<CurrentListener>();
	private List<VoltageListener> listenerVoltage = new CopyOnWriteArrayList<VoltageListener>();
	private List<PowerListener> listenerPower = new CopyOnWriteArrayList<PowerListener>();
	private List<CurrentReachedListener> listenerCurrentReached = new CopyOnWriteArrayList<CurrentReachedListener>();
	private List<VoltageReachedListener> listenerVoltageReached = new CopyOnWriteArrayList<VoltageReachedListener>();
	private List<PowerReachedListener> listenerPowerReached = new CopyOnWriteArrayList<PowerReachedListener>();

	public class Configuration {
		public short averaging;
		public short voltageConversionTime;
		public short currentConversionTime;

		public String toString() {
			return "[" + "averaging = " + averaging + ", " + "voltageConversionTime = " + voltageConversionTime + ", " + "currentConversionTime = " + currentConversionTime + "]";
		}
	}

	public class Calibration {
		public int gainMultiplier;
		public int gainDivisor;

		public String toString() {
			return "[" + "gainMultiplier = " + gainMultiplier + ", " + "gainDivisor = " + gainDivisor + "]";
		}
	}

	public class CurrentCallbackThreshold {
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class VoltageCallbackThreshold {
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class PowerCallbackThreshold {
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletVoltageCurrent#setCurrentCallbackPeriod(long)}. The parameter is the current of the
	 * sensor.
	 * 
	 * The {@link BrickletVoltageCurrent.CurrentListener} listener is only triggered if the current has changed since
	 * the last triggering.
	 */
	public interface CurrentListener extends DeviceListener {
		public void current(int current);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletVoltageCurrent#setVoltageCallbackPeriod(long)}. The parameter is the voltage of
	 * the sensor.
	 * 
	 * The {@link BrickletVoltageCurrent.VoltageListener} listener is only triggered if the voltage has changed since
	 * the last triggering.
	 */
	public interface VoltageListener extends DeviceListener {
		public void voltage(int voltage);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletVoltageCurrent#setPowerCallbackPeriod(long)}. The parameter is the power of the
	 * sensor.
	 * 
	 * The {@link BrickletVoltageCurrent.PowerListener} listener is only triggered if the power has changed since the
	 * last triggering.
	 */
	public interface PowerListener extends DeviceListener {
		public void power(int power);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link BrickletVoltageCurrent#setCurrentCallbackThreshold(char, int, int)} is reached.
	 * The parameter is the current of the sensor.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link BrickletVoltageCurrent#setDebouncePeriod(long)}.
	 */
	public interface CurrentReachedListener extends DeviceListener {
		public void currentReached(int current);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link BrickletVoltageCurrent#setVoltageCallbackThreshold(char, int, int)} is reached.
	 * The parameter is the voltage of the sensor.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link BrickletVoltageCurrent#setDebouncePeriod(long)}.
	 */
	public interface VoltageReachedListener extends DeviceListener {
		public void voltageReached(int voltage);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link BrickletVoltageCurrent#setPowerCallbackThreshold(char, int, int)} is reached.
	 * The parameter is the power of the sensor.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link BrickletVoltageCurrent#setDebouncePeriod(long)}.
	 */
	public interface PowerReachedListener extends DeviceListener {
		public void powerReached(int power);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletVoltageCurrent(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CURRENT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_POWER)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CALIBRATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CALIBRATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CURRENT_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CURRENT_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_POWER_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_POWER_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_POWER_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_POWER_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_CURRENT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int current = (bb.getInt());

				for (CurrentListener listener: listenerCurrent) {
					listener.current(current);
				}
			}
		};

		callbacks[CALLBACK_VOLTAGE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int voltage = (bb.getInt());

				for (VoltageListener listener: listenerVoltage) {
					listener.voltage(voltage);
				}
			}
		};

		callbacks[CALLBACK_POWER] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int power = (bb.getInt());

				for (PowerListener listener: listenerPower) {
					listener.power(power);
				}
			}
		};

		callbacks[CALLBACK_CURRENT_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int current = (bb.getInt());

				for (CurrentReachedListener listener: listenerCurrentReached) {
					listener.currentReached(current);
				}
			}
		};

		callbacks[CALLBACK_VOLTAGE_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int voltage = (bb.getInt());

				for (VoltageReachedListener listener: listenerVoltageReached) {
					listener.voltageReached(voltage);
				}
			}
		};

		callbacks[CALLBACK_POWER_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int power = (bb.getInt());

				for (PowerReachedListener listener: listenerPowerReached) {
					listener.powerReached(power);
				}
			}
		};
	}

	/**
	 * Returns the current.
	 * 
	 * If you want to get the current periodically, it is recommended to use the
	 * {@link BrickletVoltageCurrent.CurrentListener} listener and set the period with
	 * {@link BrickletVoltageCurrent#setCurrentCallbackPeriod(long)}.
	 */
	public int getCurrent() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CURRENT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int current = (bb.getInt());

		return current;
	}

	/**
	 * Returns the voltage.
	 * 
	 * If you want to get the voltage periodically, it is recommended to use the
	 * {@link BrickletVoltageCurrent.VoltageListener} listener and set the period with
	 * {@link BrickletVoltageCurrent#setVoltageCallbackPeriod(long)}.
	 */
	public int getVoltage() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VOLTAGE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = (bb.getInt());

		return voltage;
	}

	/**
	 * Returns the power.
	 * 
	 * If you want to get the power periodically, it is recommended to use the
	 * {@link BrickletVoltageCurrent.PowerListener} listener and set the period with
	 * {@link BrickletVoltageCurrent#setPowerCallbackPeriod(long)}.
	 */
	public int getPower() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_POWER, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int power = (bb.getInt());

		return power;
	}

	/**
	 * Sets the configuration of the Voltage/Current Bricklet. It is
	 * possible to configure number of averages as well as
	 * voltage and current conversion time.
	 */
	public void setConfiguration(short averaging, short voltageConversionTime, short currentConversionTime) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SET_CONFIGURATION, this);

		bb.put((byte)averaging);
		bb.put((byte)voltageConversionTime);
		bb.put((byte)currentConversionTime);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletVoltageCurrent#setConfiguration(short, short, short)}.
	 */
	public Configuration getConfiguration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.averaging = IPConnection.unsignedByte(bb.get());
		obj.voltageConversionTime = IPConnection.unsignedByte(bb.get());
		obj.currentConversionTime = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Since the shunt resistor that is used to measure the current is not
	 * perfectly precise, it needs to be calibrated by a multiplier and
	 * divisor if a very precise reading is needed.
	 * 
	 * For example, if you are expecting a measurement of 1000mA and you
	 * are measuring 1023mA, you can calibrate the Voltage/Current Bricklet
	 * by setting the multiplier to 1000 and the divisor to 1023.
	 */
	public void setCalibration(int gainMultiplier, int gainDivisor) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_CALIBRATION, this);

		bb.putShort((short)gainMultiplier);
		bb.putShort((short)gainDivisor);

		sendRequest(bb.array());
	}

	/**
	 * Returns the calibration as set by {@link BrickletVoltageCurrent#setCalibration(int, int)}.
	 */
	public Calibration getCalibration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CALIBRATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Calibration obj = new Calibration();
		obj.gainMultiplier = IPConnection.unsignedShort(bb.getShort());
		obj.gainDivisor = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Sets the period with which the {@link BrickletVoltageCurrent.CurrentListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletVoltageCurrent.CurrentListener} listener is only triggered if the current has changed since
	 * the last triggering.
	 */
	public void setCurrentCallbackPeriod(long period) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_CURRENT_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletVoltageCurrent#setCurrentCallbackPeriod(long)}.
	 */
	public long getCurrentCallbackPeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CURRENT_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickletVoltageCurrent.VoltageListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletVoltageCurrent.VoltageListener} listener is only triggered if the voltage has changed since
	 * the last triggering.
	 */
	public void setVoltageCallbackPeriod(long period) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletVoltageCurrent#setVoltageCallbackPeriod(long)}.
	 */
	public long getVoltageCallbackPeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickletVoltageCurrent.PowerListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletVoltageCurrent.PowerListener} listener is only triggered if the power has changed since the
	 * last triggering.
	 */
	public void setPowerCallbackPeriod(long period) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_POWER_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletVoltageCurrent#getPowerCallbackPeriod()}.
	 */
	public long getPowerCallbackPeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_POWER_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the thresholds for the {@link BrickletVoltageCurrent.CurrentReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the current is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the current is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the current is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the current is greater than the min value (max is ignored)"
	 * \endverbatim
	 */
	public void setCurrentCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)17, FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD, this);

		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link BrickletVoltageCurrent#setCurrentCallbackThreshold(char, int, int)}.
	 */
	public CurrentCallbackThreshold getCurrentCallbackThreshold() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		CurrentCallbackThreshold obj = new CurrentCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the thresholds for the {@link BrickletVoltageCurrent.VoltageReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the voltage is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the voltage is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the voltage is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the voltage is greater than the min value (max is ignored)"
	 * \endverbatim
	 */
	public void setVoltageCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)17, FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD, this);

		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link BrickletVoltageCurrent#setVoltageCallbackThreshold(char, int, int)}.
	 */
	public VoltageCallbackThreshold getVoltageCallbackThreshold() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		VoltageCallbackThreshold obj = new VoltageCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the thresholds for the {@link BrickletVoltageCurrent.PowerReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the power is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the power is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the power is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the power is greater than the min value (max is ignored)"
	 * \endverbatim
	 */
	public void setPowerCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)17, FUNCTION_SET_POWER_CALLBACK_THRESHOLD, this);

		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link BrickletVoltageCurrent#setPowerCallbackThreshold(char, int, int)}.
	 */
	public PowerCallbackThreshold getPowerCallbackThreshold() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_POWER_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PowerCallbackThreshold obj = new PowerCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the period with which the threshold listeners
	 * 
	 * * {@link BrickletVoltageCurrent.CurrentReachedListener},
	 * * {@link BrickletVoltageCurrent.VoltageReachedListener},
	 * * {@link BrickletVoltageCurrent.PowerReachedListener}
	 * 
	 * are triggered, if the thresholds
	 * 
	 * * {@link BrickletVoltageCurrent#setCurrentCallbackThreshold(char, int, int)},
	 * * {@link BrickletVoltageCurrent#setVoltageCallbackThreshold(char, int, int)},
	 * * {@link BrickletVoltageCurrent#setPowerCallbackThreshold(char, int, int)}
	 * 
	 * keep being reached.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the debounce period as set by {@link BrickletVoltageCurrent#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnection.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Current listener.
	 */
	public void addCurrentListener(CurrentListener listener) {
		listenerCurrent.add(listener);
	}

	/**
	 * Removes a Current listener.
	 */
	public void removeCurrentListener(CurrentListener listener) {
		listenerCurrent.remove(listener);
	}

	/**
	 * Adds a Voltage listener.
	 */
	public void addVoltageListener(VoltageListener listener) {
		listenerVoltage.add(listener);
	}

	/**
	 * Removes a Voltage listener.
	 */
	public void removeVoltageListener(VoltageListener listener) {
		listenerVoltage.remove(listener);
	}

	/**
	 * Adds a Power listener.
	 */
	public void addPowerListener(PowerListener listener) {
		listenerPower.add(listener);
	}

	/**
	 * Removes a Power listener.
	 */
	public void removePowerListener(PowerListener listener) {
		listenerPower.remove(listener);
	}

	/**
	 * Adds a CurrentReached listener.
	 */
	public void addCurrentReachedListener(CurrentReachedListener listener) {
		listenerCurrentReached.add(listener);
	}

	/**
	 * Removes a CurrentReached listener.
	 */
	public void removeCurrentReachedListener(CurrentReachedListener listener) {
		listenerCurrentReached.remove(listener);
	}

	/**
	 * Adds a VoltageReached listener.
	 */
	public void addVoltageReachedListener(VoltageReachedListener listener) {
		listenerVoltageReached.add(listener);
	}

	/**
	 * Removes a VoltageReached listener.
	 */
	public void removeVoltageReachedListener(VoltageReachedListener listener) {
		listenerVoltageReached.remove(listener);
	}

	/**
	 * Adds a PowerReached listener.
	 */
	public void addPowerReachedListener(PowerReachedListener listener) {
		listenerPowerReached.add(listener);
	}

	/**
	 * Removes a PowerReached listener.
	 */
	public void removePowerReachedListener(PowerReachedListener listener) {
		listenerPowerReached.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletVoltageCurrent.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletVoltageCurrent.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletVoltageCurrentConfig cfg = (BrickletVoltageCurrentConfig) config.as(BrickletVoltageCurrentConfig.class);
        this.addCurrentListener((current) -> {if(true) {updateStateFn.accept("BrickletVoltageCurrentCurrent", transformBrickletVoltageCurrentCurrentCallback0(current, cfg));}});
		this.addVoltageListener((voltage) -> {if(true) {updateStateFn.accept("BrickletVoltageCurrentVoltage", transformBrickletVoltageCurrentVoltageCallback0(voltage, cfg));}});
		this.addPowerListener((power) -> {if(true) {updateStateFn.accept("BrickletVoltageCurrentPower", transformBrickletVoltageCurrentPowerCallback0(power, cfg));}});
        this.setConfiguration(cfg.averaging.shortValue(), cfg.voltageConversionTime.shortValue(), cfg.currentConversionTime.shortValue());
		{
		BrickletVoltageCurrentCurrentConfig channelCfg = getChannelConfigFn.apply("BrickletVoltageCurrentCurrent").as(BrickletVoltageCurrentCurrentConfig.class);
		this.setCurrentCallbackPeriod(channelCfg.updateInterval);
		this.setCurrentCallbackThreshold('x', 0, 0);
		}
		{
		BrickletVoltageCurrentVoltageConfig channelCfg = getChannelConfigFn.apply("BrickletVoltageCurrentVoltage").as(BrickletVoltageCurrentVoltageConfig.class);
		this.setVoltageCallbackPeriod(channelCfg.updateInterval);
		this.setVoltageCallbackThreshold('x', 0, 0);
		}
		{
		BrickletVoltageCurrentPowerConfig channelCfg = getChannelConfigFn.apply("BrickletVoltageCurrentPower").as(BrickletVoltageCurrentPowerConfig.class);
		this.setPowerCallbackPeriod(channelCfg.updateInterval);
		this.setPowerCallbackThreshold('x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletVoltageCurrentConfig cfg = (BrickletVoltageCurrentConfig) config.as(BrickletVoltageCurrentConfig.class);
        this.listenerCurrent.clear();
		this.listenerVoltage.clear();
		this.listenerPower.clear();
        this.setCurrentCallbackPeriod(0);
		this.setVoltageCallbackPeriod(0);
		this.setPowerCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletVoltageCurrentConfig cfg = (BrickletVoltageCurrentConfig) config.as(BrickletVoltageCurrentConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletVoltageCurrentCurrent");
		result.add("BrickletVoltageCurrentVoltage");
		result.add("BrickletVoltageCurrentPower");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletVoltageCurrentVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletVoltageCurrentVoltage"), "Measured Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletVoltageCurrentVoltage")).withDescription("The measured voltage between 0 and 36V.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(36)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletVoltageCurrentCurrent":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletVoltageCurrentCurrent"), "Measured Current", "Number:ElectricCurrent").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletVoltageCurrentCurrent")).withDescription("The measured current between -20 and 20A.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-20)).withMaximum(BigDecimal.valueOf(20)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletVoltageCurrentPower":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletVoltageCurrentPower"), "Measured Power", "Number:Power").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletVoltageCurrentPower")).withDescription("The measured power between 0 and 720W.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(720)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Voltage/Current Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures power, DC voltage and DC current up to 720W/36V/20A").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletVoltageCurrentCurrent", new ChannelTypeUID("tinkerforge", "BrickletVoltageCurrentCurrent")).withLabel("Measured Current").build(), new ChannelDefinitionBuilder("BrickletVoltageCurrentVoltage", new ChannelTypeUID("tinkerforge", "BrickletVoltageCurrentVoltage")).withLabel("Measured Voltage").build(), new ChannelDefinitionBuilder("BrickletVoltageCurrentPower", new ChannelTypeUID("tinkerforge", "BrickletVoltageCurrentPower")).withLabel("Measured Power").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletvoltagecurrent":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("averaging", Type.INTEGER).withDefault("3").withDescription("Configures the number of samples to average over.").withLabel("Averaging").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "1"), new ParameterOption("1", "4"), new ParameterOption("2", "16"), new ParameterOption("3", "64"), new ParameterOption("4", "128"), new ParameterOption("5", "256"), new ParameterOption("6", "512"), new ParameterOption("7", "1024"))).build(), ConfigDescriptionParameterBuilder.create("voltageConversionTime", Type.INTEGER).withDefault("4").withDescription("Configures the voltage conversion time.").withLabel("Voltage Conversion Time").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "140µs"), new ParameterOption("1", "204µs"), new ParameterOption("2", "332µs"), new ParameterOption("3", "588µs"), new ParameterOption("4", "1.1ms"), new ParameterOption("5", "2.116ms"), new ParameterOption("6", "4.156ms"), new ParameterOption("7", "8.244ms"))).build(), ConfigDescriptionParameterBuilder.create("currentConversionTime", Type.INTEGER).withDefault("4").withDescription("Configures the current conversion time.").withLabel("Current Conversion Time").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "140µs"), new ParameterOption("1", "204µs"), new ParameterOption("2", "332µs"), new ParameterOption("3", "588µs"), new ParameterOption("4", "1.1ms"), new ParameterOption("5", "2.116ms"), new ParameterOption("6", "4.156ms"), new ParameterOption("7", "8.244ms"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletVoltageCurrentVoltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletVoltageCurrentCurrent":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletVoltageCurrentPower":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletVoltageCurrentConfig cfg = (BrickletVoltageCurrentConfig) config.as(BrickletVoltageCurrentConfig.class);
        switch(channel) {
            case "BrickletVoltageCurrentCurrent": {
                   BrickletVoltageCurrentCurrentConfig channelCfg = channelConfig.as(BrickletVoltageCurrentCurrentConfig.class);
                   {
            int value = this.getCurrent();
            if(true)
                updateStateFn.accept(channel, transformBrickletVoltageCurrentCurrentGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletVoltageCurrentVoltage": {
                   BrickletVoltageCurrentVoltageConfig channelCfg = channelConfig.as(BrickletVoltageCurrentVoltageConfig.class);
                   {
            int value = this.getVoltage();
            if(true)
                updateStateFn.accept(channel, transformBrickletVoltageCurrentVoltageGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletVoltageCurrentPower": {
                   BrickletVoltageCurrentPowerConfig channelCfg = channelConfig.as(BrickletVoltageCurrentPowerConfig.class);
                   {
            int value = this.getPower();
            if(true)
                updateStateFn.accept(channel, transformBrickletVoltageCurrentPowerGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletVoltageCurrentConfig cfg = (BrickletVoltageCurrentConfig) config.as(BrickletVoltageCurrentConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletVoltageCurrentCurrentCallback0(int current, BrickletVoltageCurrentConfig cfg) {
        return new QuantityType<>(current / 1000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletVoltageCurrentVoltageCallback0(int voltage, BrickletVoltageCurrentConfig cfg) {
        return new QuantityType<>(voltage / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletVoltageCurrentPowerCallback0(int power, BrickletVoltageCurrentConfig cfg) {
        return new QuantityType<>(power / 1000.0, SmartHomeUnits.WATT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletVoltageCurrentCurrentGetter0(int value, BrickletVoltageCurrentConfig cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletVoltageCurrentVoltageGetter0(int value, BrickletVoltageCurrentConfig cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletVoltageCurrentPowerGetter0(int value, BrickletVoltageCurrentConfig cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.WATT);
    }
}
